import { BehaviorSubject } from 'rxjs';
import { GraphqlService } from '../../core/graphql/graphql.service';
import { NetworkService } from '../../core/services/network.service';
import { EntitiesStorage } from '../../core/services/storage/entities-storage.service';
import { Person } from '../../core/services/model/person.model';
import { SortDirection } from '@angular/material/sort';
import { EntitiesServiceLoadOptions, EntityServiceLoadOptions, LoadResult, SuggestService } from '../../shared/services/entity-service.class';
import { PlatformService } from '../../core/services/platform.service';
import { PersonFilter } from './filter/person.filter';
import { BaseEntityService } from '../../core/services/base-entity-service.class';
import * as i0 from "@angular/core";
export declare const PersonFragments: {
    person: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
};
export declare class PersonService extends BaseEntityService<Person, PersonFilter> implements SuggestService<Person, PersonFilter> {
    protected graphql: GraphqlService;
    protected platform: PlatformService;
    protected network: NetworkService;
    protected entities: EntitiesStorage;
    constructor(graphql: GraphqlService, platform: PlatformService, network: NetworkService, entities: EntitiesStorage);
    loadAll(offset: number, size: number, sortBy?: keyof Person | string, sortDirection?: SortDirection, filter?: Partial<PersonFilter>, opts?: EntitiesServiceLoadOptions & {
        debug?: boolean;
    }): Promise<LoadResult<Person>>;
    loadAllLocally(offset: number, size: number, sortBy?: string, sortDirection?: SortDirection, filter?: Partial<PersonFilter>, opts?: EntitiesServiceLoadOptions & {
        debug?: boolean;
    }): Promise<LoadResult<Person>>;
    suggest(value: any, filter?: Partial<PersonFilter>, sortBy?: keyof Person | string, sortDirection?: SortDirection, opts?: EntitiesServiceLoadOptions): Promise<LoadResult<Person>>;
    executeImport(filter: Partial<PersonFilter>, opts: {
        progression?: BehaviorSubject<number>;
        maxProgression?: number;
    }): Promise<void>;
    loadById(id: number, opts?: EntityServiceLoadOptions): Promise<Person>;
    loadByPubkey(pubkey: string, opts?: EntityServiceLoadOptions): Promise<Person>;
    protected asObject(source: Person | any): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<PersonService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PersonService>;
}
