import { UntypedFormBuilder, ValidatorFn } from '@angular/forms';
import { Person } from '../../../core/services/model/person.model';
import { AccountService } from '../../../core/services/account.service';
import { FormFieldDefinition } from '../../../shared/form/field.model';
import { AppValidatorService } from '../../../core/services/validator/base.validator.class';
import { TranslateService } from '@ngx-translate/core';
import * as i0 from "@angular/core";
export interface PersonValidatorOptions {
    withAvatar?: boolean;
    withUsername?: boolean;
    withUsernameExtranet?: boolean;
}
export declare class PersonValidatorService<T extends Person = Person, O extends PersonValidatorOptions = PersonValidatorOptions> extends AppValidatorService<T, O> {
    protected accountService: AccountService;
    constructor(formBuilder: UntypedFormBuilder, translate: TranslateService, accountService: AccountService);
    getFormGroupConfig(data?: T, opts?: O): {
        [key: string]: any;
    };
    getValidators(field: FormFieldDefinition): ValidatorFn | ValidatorFn[];
    protected fillDefaultOptions(opts?: O): O;
    static ɵfac: i0.ɵɵFactoryDeclaration<PersonValidatorService<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PersonValidatorService<any, any>>;
}
