import { Injector, OnInit } from '@angular/core';
import { Person } from '../../core/services/model/person.model';
import { PersonService } from '../services/person.service';
import { AccountService } from '../../core/services/account.service';
import { AbstractControl, UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { AppTable } from '../../core/table/table.class';
import { ValidatorService } from '@e-is/ngx-material-table';
import { FormFieldDefinition } from '../../shared/form/field.model';
import { PersonFilter } from '../services/filter/person.filter';
import { ConfigService } from '../../core/services/config.service';
import { MatExpansionPanel } from '@angular/material/expansion';
import { MessageService } from '../../social/message/message.service';
import { MenuService } from '../../core/menu/menu.service';
import * as i0 from "@angular/core";
export declare class UsersPage extends AppTable<Person, PersonFilter> implements OnInit {
    protected accountService: AccountService;
    protected validatorService: ValidatorService;
    protected configService: ConfigService;
    protected dataService: PersonService;
    protected messageService: MessageService;
    protected menuService: MenuService;
    readonly canEdit: boolean;
    readonly canSendMessage: boolean;
    readonly filterForm: UntypedFormGroup;
    readonly profiles: import("../../core/services/model/person.model").UserProfileLabel[];
    readonly statusList: readonly import("../../core/services/model/referential.model").IStatus[];
    readonly statusById: Readonly<import("@sumaris-net/ngx-components").KeyValueType<import("../../core/services/model/referential.model").IStatus>>;
    protected additionalFields: FormFieldDefinition[];
    protected filterCriteriaCount: number;
    protected defaultCompact: boolean;
    set showUsernameColumn(value: boolean);
    get showUsernameColumn(): boolean;
    set showUsernameExtranetColumn(value: boolean);
    get showUsernameExtranetColumn(): boolean;
    compact: boolean;
    usePageSettings: boolean;
    sticky: boolean;
    stickyEnd: boolean;
    canDownload: boolean;
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, accountService: AccountService, validatorService: ValidatorService, configService: ConfigService, dataService: PersonService, messageService: MessageService, menuService: MenuService, environment: any);
    filterExpansionPanel: MatExpansionPanel;
    get firstUserColumn(): string;
    ngOnInit(): Promise<void>;
    applyFilterAndClosePanel(event?: Event): void;
    resetFilter(event?: Event): void;
    protected restoreFilterOrLoad(): Promise<void>;
    clearControlValue(event: Event, formControl: AbstractControl): boolean;
    openComposeMessageModal(event?: Event): Promise<any>;
    restoreCompactMode(opts?: {
        emitEvent?: boolean;
    }): Promise<void>;
    toggleCompactMode(): Promise<void>;
    exportToCsv(event: Event): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<UsersPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UsersPage, "app-users-table", never, { "compact": { "alias": "compact"; "required": false; }; "usePageSettings": { "alias": "usePageSettings"; "required": false; }; "sticky": { "alias": "sticky"; "required": false; }; "stickyEnd": { "alias": "stickyEnd"; "required": false; }; "canDownload": { "alias": "canDownload"; "required": false; }; }, {}, never, never, false, never>;
    static ngAcceptInputType_compact: unknown;
    static ngAcceptInputType_usePageSettings: unknown;
    static ngAcceptInputType_sticky: unknown;
    static ngAcceptInputType_stickyEnd: unknown;
    static ngAcceptInputType_canDownload: unknown;
}
