import { InjectionToken, OnDestroy } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { Department } from '../services/model/department.model';
import { TranslateService } from '@ngx-translate/core';
import { ConfigService } from '../services/config.service';
import { Configuration } from '../services/model/config.model';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare const APP_ABOUT_DEVELOPERS: InjectionToken<Partial<Department>[]>;
export declare const APP_ABOUT_PARTNERS: InjectionToken<Partial<Department>[]>;
export declare class AboutModal implements OnDestroy {
    protected translate: TranslateService;
    protected modalController: ModalController;
    protected configService: ConfigService;
    protected environment: any;
    developers: Partial<Department>[];
    partners: Partial<Department>[];
    readonly name: string;
    readonly version: string;
    readonly sourceUrl: string;
    readonly config$: Observable<Configuration>;
    reportIssueUrl: string;
    forumUrl: string;
    helpUrl: string;
    private readonly _subscription;
    constructor(translate: TranslateService, modalController: ModalController, configService: ConfigService, environment: any, developers: Partial<Department>[], partners: Partial<Department>[]);
    ngOnDestroy(): void;
    close(): Promise<void>;
    protected setConfig(config?: Configuration): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AboutModal, [null, null, null, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AboutModal, "app-about-modal", never, {}, {}, never, never, false, never>;
}
