import { ChangeDetectorRef, Injector, OnDestroy, OnInit } from '@angular/core';
import { Subscription } from 'rxjs';
import { AccountService } from '../services/account.service';
import { Account } from '../services/model/account.model';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { AccountValidatorService } from '../services/validator/account.validator';
import { AppForm } from '../form/form.class';
import { CanLeave } from '../form/form.utils';
import { FormFieldDefinition } from '../../shared/form/field.model';
import { LocaleConfig } from '../services/model/settings.model';
import { NetworkService } from '../services/network.service';
import { MatTabGroup } from '@angular/material/tabs';
import { ConfigService } from '../services/config.service';
import { AppPropertiesTable } from '../form/properties/properties.table';
import { UserTokenTable } from './token.table';
import { NavController } from '@ionic/angular';
import { Configuration } from '../services/model/config.model';
import * as i0 from "@angular/core";
export declare class AccountPage extends AppForm<Account> implements OnInit, OnDestroy, CanLeave {
    formBuilder: UntypedFormBuilder;
    accountService: AccountService;
    network: NetworkService;
    protected navController: NavController;
    protected validatorService: AccountValidatorService;
    protected configService: ConfigService;
    protected cd: ChangeDetectorRef;
    tabGroup: MatTabGroup;
    propertiesTable: AppPropertiesTable;
    tokensTable: UserTokenTable;
    protected selectedTabIndex: number;
    protected isLogin: boolean;
    protected changesSubscription: Subscription;
    protected networkSubscription: Subscription;
    protected email: {
        confirmed: boolean;
        notConfirmed: boolean;
        sending: boolean;
        error: any;
    };
    protected additionalFields: FormFieldDefinition[];
    protected optionDefinitions: FormFieldDefinition[];
    get settingsForm(): UntypedFormGroup;
    protected locales: LocaleConfig[];
    protected latLongFormats: import("../../shared/material/latlong/latlong.utils").LatLongPattern[];
    protected saving: boolean;
    protected submitted: boolean;
    protected accountReadOnly: boolean;
    protected readonly mobile: boolean;
    get valid(): boolean;
    get invalid(): boolean;
    get dirty(): boolean;
    protected showLatLonFormat: boolean;
    protected canChangePassword: boolean;
    protected showSecurityDetails: boolean;
    protected showTechnicalDetails: boolean;
    protected showApiTokens: boolean;
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, accountService: AccountService, network: NetworkService, navController: NavController, validatorService: AccountValidatorService, configService: ConfigService, cd: ChangeDetectorRef, locales: LocaleConfig[]);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onLogin(account: Account): void;
    onLogout(): void;
    setValue(data: Account, opts?: {
        emitEvent?: boolean;
        onlySelf?: boolean;
    }): Promise<void>;
    refresh(_?: Event): Promise<Account>;
    startListenChanges(): void;
    stopListenChanges(): void;
    sendConfirmationEmail(event: MouseEvent): Promise<boolean>;
    save(event?: Event): Promise<boolean>;
    enable(opts?: {
        onlySelf?: boolean;
        emitEvent?: boolean;
    }): void;
    cancel(): Promise<void>;
    close(_?: Event): Promise<boolean>;
    handleRefresh(event: BeforeUnloadEvent): void;
    protected onConfigLoaded(config: Configuration): void;
    protected markForCheck(): void;
    protected openChangePasswordPage(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AccountPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AccountPage, "app-account-page", never, {}, {}, never, never, false, never>;
}
