import { TokenScope, UserToken } from '../services/model/token.model';
import { ChangeDetectorRef, Injector, OnInit } from '@angular/core';
import { UserTokenValidatorService } from '../services/validator/user-token.validator';
import { MatAutocompleteFieldConfig } from '../../shared/material/autocomplete/material.autocomplete.config';
import { AppForm } from '../form/form.class';
import { AccountService } from '../services/account.service';
import * as i0 from "@angular/core";
export declare class NewTokenForm extends AppForm<UserToken> implements OnInit {
    protected validator: UserTokenValidatorService;
    protected accountService: AccountService;
    protected cd: ChangeDetectorRef;
    protected tokenConfig: MatAutocompleteFieldConfig;
    showScopes: boolean;
    tokenScopes: TokenScope[];
    existingNames: string[];
    mobile: boolean;
    private readonly platform;
    constructor(injector: Injector, validator: UserTokenValidatorService, accountService: AccountService, cd: ChangeDetectorRef);
    get valid(): boolean;
    get invalid(): boolean;
    ngOnInit(): void;
    generate(event: UIEvent): Promise<void>;
    copy(event: UIEvent): Promise<void>;
    getValue(): Promise<UserToken>;
    protected getFlags(scopes: TokenScope[]): number;
    protected markForCheck(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NewTokenForm, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NewTokenForm, "app-new-token-form", never, { "showScopes": { "alias": "showScopes"; "required": false; }; "tokenScopes": { "alias": "tokenScopes"; "required": false; }; "existingNames": { "alias": "existingNames"; "required": false; }; "mobile": { "alias": "mobile"; "required": false; }; }, {}, never, never, false, never>;
}
