import { AppEntityEditorModal, IEntityEditorModalOptions } from '../form/entity/entity-editor-modal.class';
import { TokenScope, UserToken } from '../services/model/token.model';
import { UntypedFormGroup } from '@angular/forms';
import { Injector, OnInit } from '@angular/core';
import { AccountService } from '../services/account.service';
import { NewTokenForm } from './new-token.form';
import * as i0 from "@angular/core";
export interface INewTokenOptions extends IEntityEditorModalOptions<UserToken> {
    showScopes: boolean;
    tokenScopes: TokenScope[];
    existingNames: string[];
}
export declare class NewTokenModal extends AppEntityEditorModal<UserToken> implements OnInit, INewTokenOptions {
    protected accountService: AccountService;
    showScopes: boolean;
    tokenScopes: TokenScope[];
    existingNames: string[];
    newTokenForm: NewTokenForm;
    constructor(injector: Injector, accountService: AccountService);
    ngOnInit(): void;
    protected computeTitle(data: UserToken): Promise<string>;
    protected get form(): UntypedFormGroup;
    protected getFirstInvalidTabIndex(): number;
    protected registerForms(): void;
    setValue(data: UserToken): Promise<void> | void;
    protected getValue(): Promise<UserToken>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NewTokenModal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NewTokenModal, "app-new-token-modal", never, { "showScopes": { "alias": "showScopes"; "required": false; }; "tokenScopes": { "alias": "tokenScopes"; "required": false; }; "existingNames": { "alias": "existingNames"; "required": false; }; }, {}, never, ["*"], false, never>;
}
