import { Injector, OnInit } from '@angular/core';
import { ValidatorService } from '@e-is/ngx-material-table';
import { TokenScope, UserToken } from '../services/model/token.model';
import { AppInMemoryTable } from '../table/memory-table.class';
import { Environment } from '../../../environments/environment.class';
import { ConfigService } from '../services/config.service';
import { Configuration } from '../services/model/config.model';
import * as i0 from "@angular/core";
export declare class UserTokenTable extends AppInMemoryTable<UserToken> implements OnInit {
    protected configService: ConfigService;
    useSticky: boolean;
    protected showScopes: boolean;
    protected defaultScope: string;
    protected tokenScopes: TokenScope[];
    constructor(injector: Injector, validatorService: ValidatorService, configService: ConfigService, environment: Environment, tokenScopes: TokenScope[]);
    ngOnInit(): void;
    get value(): UserToken[];
    set value(data: UserToken[]);
    setValue(value: UserToken[], opts?: {
        emitEvent?: boolean;
    }): void;
    addToken(event: UIEvent): Promise<void>;
    display(scopes: TokenScope[]): string;
    protected onConfigLoaded(config: Configuration): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserTokenTable, [null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UserTokenTable, "app-user-token-table", never, { "useSticky": { "alias": "useSticky"; "required": false; }; }, {}, never, never, false, never>;
}
