import { ChangeDetectorRef, EventEmitter, Injector, OnInit } from '@angular/core';
import { UntypedFormBuilder } from '@angular/forms';
import { ModalController } from '@ionic/angular';
import { AuthData } from '../services/account.service';
import { NetworkService } from '../services/network.service';
import { LocalSettingsService } from '../services/local-settings.service';
import { AppForm } from '../form/form.class';
import { Environment } from '../../../environments/environment.class';
import { ConfigService } from '../services/config.service';
import * as i0 from "@angular/core";
export declare class AppAuthForm extends AppForm<AuthData> implements OnInit {
    private configService;
    private modalCtrl;
    network: NetworkService;
    private cd;
    protected environment: Environment;
    protected readonly mobile: boolean;
    protected canWorkOffline: boolean;
    protected showPwd: boolean;
    protected canRegister: boolean;
    protected canResetPassword: boolean;
    protected usernamePlaceholder: string;
    onCancel: EventEmitter<any>;
    onSubmit: EventEmitter<AuthData>;
    disable(opts?: {
        onlySelf?: boolean;
        emitEvent?: boolean;
    }): void;
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, settings: LocalSettingsService, configService: ConfigService, modalCtrl: ModalController, network: NetworkService, cd: ChangeDetectorRef, environment: Environment);
    ngOnInit(): void;
    cancel(): Promise<void>;
    doSubmit(event?: Event): Promise<void>;
    register(): void;
    resetPassword(): void;
    protected markForCheck(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppAuthForm, [null, null, null, null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppAuthForm, "app-auth-form", never, {}, { "onCancel": "onCancel"; "onSubmit": "onSubmit"; }, never, never, false, never>;
}
