import { EventEmitter, OnDestroy } from '@angular/core';
import { Hotkeys } from '../../../shared/hotkeys/hotkeys.service';
import { MenuService } from '../../menu/menu.service';
import { PredefinedColors } from '@ionic/core';
import * as i0 from "@angular/core";
export declare abstract class FormButtonsBarToken {
    abstract onCancel: EventEmitter<Event>;
    abstract onSave: EventEmitter<Event>;
    abstract onNext: EventEmitter<Event>;
    abstract onBack: EventEmitter<Event>;
}
export declare class FormButtonsBarComponent implements FormButtonsBarToken, OnDestroy {
    protected menu: MenuService;
    private _subscription;
    disabled: boolean;
    disabledCancel: boolean;
    disabledEscape: boolean;
    classList: string;
    saveButtonColor: PredefinedColors;
    backText: string;
    cancelText: string;
    nextText: string;
    showBack: boolean;
    showCancel: boolean;
    showNext: boolean;
    showSave: boolean;
    onCancel: EventEmitter<Event>;
    onSave: EventEmitter<Event>;
    onNext: EventEmitter<Event>;
    onBack: EventEmitter<Event>;
    onSaveAndClose: EventEmitter<Event>;
    onSaveAndNext: EventEmitter<Event>;
    constructor(hotkeys: Hotkeys, menu: MenuService);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormButtonsBarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormButtonsBarComponent, "app-form-buttons-bar", never, { "disabled": { "alias": "disabled"; "required": false; }; "disabledCancel": { "alias": "disabledCancel"; "required": false; }; "disabledEscape": { "alias": "disabledEscape"; "required": false; }; "classList": { "alias": "classList"; "required": false; }; "saveButtonColor": { "alias": "saveButtonColor"; "required": false; }; "backText": { "alias": "backText"; "required": false; }; "cancelText": { "alias": "cancelText"; "required": false; }; "nextText": { "alias": "nextText"; "required": false; }; "showBack": { "alias": "showBack"; "required": false; }; "showCancel": { "alias": "showCancel"; "required": false; }; "showNext": { "alias": "showNext"; "required": false; }; "showSave": { "alias": "showSave"; "required": false; }; }, { "onCancel": "onCancel"; "onSave": "onSave"; "onNext": "onNext"; "onBack": "onBack"; "onSaveAndClose": "onSaveAndClose"; "onSaveAndNext": "onSaveAndNext"; }, never, ["*", "[slot=end]", "[slot=afterSave]"], false, never>;
}
