import { AppInMemoryTable } from '../../table/memory-table.class';
import { Injector, OnInit } from '@angular/core';
import { Entity, EntityAsObjectOptions } from '../../services/model/entity.model';
import { AppValidatorService } from '../../services/validator/base.validator.class';
import { AbstractControl, UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { FormFieldDefinition, FormFieldDefinitionMap } from '../../../shared/form/field.model';
import { Environment } from '../../../../environments/environment.class';
import { TableElement } from '@e-is/ngx-material-table';
import { EntityFilter } from '../../services/model/filter.model';
import { FilterFn, Property } from '../../../shared/types';
import { MatExpansionPanel } from '@angular/material/expansion';
import * as i0 from "@angular/core";
export declare class PropertyEntity extends Entity<PropertyEntity, string> implements Property {
    static fromObject: (source: any, opts?: any) => PropertyEntity;
    definition: FormFieldDefinition;
    value: any;
    get key(): string;
    fromObject(source: any): void;
    asObject(opts?: EntityAsObjectOptions): any;
}
export declare class PropertyEntityFilter extends EntityFilter<PropertyEntityFilter, PropertyEntity> {
    static fromObject: (source: any, opts?: any) => PropertyEntityFilter;
    searchText: string;
    notDefaultOnly: boolean;
    fromObject(source: any): void;
    asObject(opts?: EntityAsObjectOptions): any;
    protected buildFilter(): FilterFn<PropertyEntity>[];
    protected isCriteriaNotEmpty(key: string, value: any): boolean;
}
export declare class PropertyEntityValidator extends AppValidatorService<PropertyEntity> {
    protected formBuilder: UntypedFormBuilder;
    constructor(formBuilder: UntypedFormBuilder);
    getFormGroupConfig(data?: PropertyEntity): {
        [p: string]: any;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<PropertyEntityValidator, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<PropertyEntityValidator, never, never, {}, {}, never, never, false, never>;
}
export declare class AppPropertiesTable extends AppInMemoryTable<PropertyEntity, PropertyEntityFilter, string> implements OnInit {
    protected injector: Injector;
    protected formBuilder: UntypedFormBuilder;
    protected validatorService: PropertyEntityValidator;
    definitions: FormFieldDefinition[];
    showToolbar: boolean;
    filterExpansionPanel: MatExpansionPanel;
    definitionsMapByKey: FormFieldDefinitionMap;
    filterForm: UntypedFormGroup;
    filterCriteriaCount: number;
    filterPanelFloating: boolean;
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, validatorService: PropertyEntityValidator, environment: Environment);
    ngOnInit(): void;
    get value(): PropertyEntity[];
    set value(data: PropertyEntity[]);
    definitionByRow: (row: TableElement<PropertyEntity>) => FormFieldDefinition;
    setValue(value: PropertyEntity[], opts?: {
        emitEvent?: boolean;
    }): void;
    clearControlValue(event: Event, formControl: AbstractControl): boolean;
    resetFilter(value?: any, opts?: {
        emitEvent: boolean;
    }): void;
    setFilter(filter: PropertyEntityFilter, opts?: {
        emitEvent?: boolean;
    }): void;
    get filterIsEmpty(): boolean;
    toggleFilterPanelFloating(): void;
    closeFilterPanel(): void;
    applyFilterAndClosePanel(event?: Event): void;
    resetProperty(event: UIEvent, row: TableElement<PropertyEntity>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppPropertiesTable, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppPropertiesTable, "app-properties-table", never, { "definitions": { "alias": "definitions"; "required": false; }; "showToolbar": { "alias": "showToolbar"; "required": false; }; }, {}, never, never, false, never>;
}
