import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { Property } from '../../../shared/types';
import { AppValidatorService } from '../../services/validator/base.validator.class';
import { FormFieldDefinition } from '../../../shared/form/field.model';
import { AppFormArray } from '../array/form-array';
import * as i0 from "@angular/core";
export interface PropertyValidatorOptions {
    definition?: FormFieldDefinition;
    valueMaxLength?: number;
}
export interface PropertiesValidatorOptions {
    definitions?: FormFieldDefinition[];
    valueMaxLength?: number;
}
export declare class PropertyValidator extends AppValidatorService<Property> {
    protected formBuilder: UntypedFormBuilder;
    constructor(formBuilder: UntypedFormBuilder);
    getFormArray(data?: any, opts?: PropertiesValidatorOptions): AppFormArray<Property, UntypedFormGroup>;
    getFormGroup(data?: Property, opts?: PropertyValidatorOptions): UntypedFormGroup;
    getFormGroupConfig(data?: Property, opts?: PropertyValidatorOptions): {
        [p: string]: any;
    };
    equals(v1: Property, v2: Property): boolean;
    isEmpty(obj: Property): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<PropertyValidator, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PropertyValidator>;
}
