import { ApolloClient, ApolloLink, Operation } from '@apollo/client/core';
import { Observable } from 'rxjs';
import { PersistentStorage } from 'apollo3-cache-persist';
import { ConnectionType } from '../services/network.types';
import { StorageService } from '../../shared/storage/storage.service';
export declare const NativeWebSocket: any;
export interface EmptyObject {
    [key: string]: any;
}
/**
 * AppWebSocket class.
 * With a hack on default Websocket, to avoid the use of protocol
 */
export declare const AppWebSocket: any;
export declare function isMutationOperation(operation: Operation): boolean;
export declare function isSubscriptionOperation(operation: Operation): boolean;
export interface TrackedQuery {
    id: string;
    name: string;
    queryJSON: string;
    variablesJSON: string;
    contextJSON: string;
}
export interface TrackableMutationContext extends Record<string, any> {
    serializationKey?: string;
    tracked?: boolean;
    timeout?: number;
}
export declare const TRACKED_QUERIES_STORAGE_KEY = "apollo-tracker-persist";
export declare function createTrackerLink(opts: {
    storage?: PersistentStorage<string>;
    onNetworkStatusChange: Observable<ConnectionType>;
    debounce?: number;
    debug?: boolean;
}): ApolloLink;
export declare function restoreTrackedQueries(opts: {
    apolloClient: ApolloClient<any>;
    storage: PersistentStorage<any>;
    debug?: boolean;
}): Promise<import("@apollo/client/core").FetchResult<any>[]>;
export declare class StorageServiceWrapper implements PersistentStorage<string> {
    private storage;
    constructor(storage: StorageService);
    getItem(key: any): Promise<any>;
    removeItem(key: any): Promise<any>;
    setItem(key: any, value: any): Promise<any>;
}
