import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { AlertController, ToastController } from '@ionic/angular';
import { ConfigService } from '../services/config.service';
import { PlatformService } from '../services/platform.service';
import { NetworkService } from '../services/network.service';
import { Environment } from '../../../environments/environment.class';
import { TranslateService } from '@ngx-translate/core';
import * as i0 from "@angular/core";
export declare interface InstallAppLink {
    name: string;
    url: string;
    platform?: 'android' | 'ios' | 'electron';
    version?: string;
    filename?: string;
    title?: string;
    description?: string;
    mimeType?: string;
    downloading?: boolean;
    location?: string;
}
export declare class AppInstallUpgradeCard implements OnInit, OnDestroy {
    private configService;
    private toastController;
    private alertController;
    private translate;
    private cd;
    platform: PlatformService;
    network: NetworkService;
    protected environment: Environment;
    private _subscription;
    loading: boolean;
    hasDownloader: boolean;
    downloading: boolean;
    waitingNetwork: boolean;
    installLinks: InstallAppLink[];
    upgradeLinks: InstallAppLink[];
    offline: boolean;
    isLogin: boolean;
    showUpgradeWarning: boolean;
    showOfflineWarning: boolean;
    showInstallButton: boolean;
    debug: boolean;
    constructor(configService: ConfigService, toastController: ToastController, alertController: AlertController, translate: TranslateService, cd: ChangeDetectorRef, platform: PlatformService, network: NetworkService, environment: Environment);
    ngOnInit(): void;
    ngOnDestroy(): void;
    download(event: Event, link: InstallAppLink): Promise<void>;
    openFile(event: Event, link: InstallAppLink): Promise<void>;
    tryOnline(): Promise<void>;
    getPlatformName(platform: 'android' | 'ios' | 'electron'): "" | "desktop" | "Android" | "iOS";
    asLink(value: any): InstallAppLink;
    private checkNeedInstallOrUpdate;
    private getCompatibleInstallLinks;
    private getCompatibleUpgradeLinks;
    private getLinks;
    private listenDownloadJobs;
    private listenDownloadJob;
    private showDownloadFailedToast;
    private showDownloadCompleteDialog;
    private markForCheck;
    private showToast;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppInstallUpgradeCard, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppInstallUpgradeCard, "app-install-upgrade-card", never, { "isLogin": { "alias": "isLogin"; "required": false; }; "showUpgradeWarning": { "alias": "showUpgradeWarning"; "required": false; }; "showOfflineWarning": { "alias": "showOfflineWarning"; "required": false; }; "showInstallButton": { "alias": "showInstallButton"; "required": false; }; "debug": { "alias": "debug"; "required": false; }; }, {}, never, never, false, never>;
}
