import { ChangeDetectorRef, OnInit } from '@angular/core';
import { IonSplitPane, MenuController, ModalController, NavController } from '@ionic/angular';
import { Account } from '../services/model/account.model';
import { AccountService } from '../services/account.service';
import { TranslateService } from '@ngx-translate/core';
import { Environment } from '../../../environments/environment.class';
import { MenuService, SplitPaneShowWhen } from './menu.service';
import { IMenuItem, MenuItem } from './menu.model';
import { ActivatedRoute, Router } from '@angular/router';
import { RxStrategyNames } from '@rx-angular/cdk/render-strategies';
import * as i0 from "@angular/core";
export declare class MenuComponent implements OnInit {
    protected accountService: AccountService;
    protected navController: NavController;
    protected menu: MenuController;
    protected modalCtrl: ModalController;
    protected translate: TranslateService;
    protected cd: ChangeDetectorRef;
    protected menuService: MenuService;
    protected router: Router;
    protected environment: Environment;
    protected route: ActivatedRoute;
    id: string;
    menuId: string;
    side: string;
    contentId: string;
    logo: string;
    appName: string;
    rxStrategy: RxStrategyNames;
    appVersion: string;
    splitPane: IonSplitPane;
    loading: boolean;
    isLogin: boolean;
    accountName: string;
    accountAvatar: string;
    accountEmail: string;
    private readonly _debug;
    private _subscription;
    constructor(accountService: AccountService, navController: NavController, menu: MenuController, modalCtrl: ModalController, translate: TranslateService, cd: ChangeDetectorRef, menuService: MenuService, router: Router, environment: Environment, route: ActivatedRoute);
    ngOnInit(): Promise<void>;
    onLogin(account: Account): Promise<void>;
    onLogout(skipRedirect?: boolean): Promise<void>;
    trackByFn(index: number, item: IMenuItem): string;
    enable(value: boolean): Promise<void>;
    open(opts?: {
        emitEvent?: boolean;
    }): Promise<boolean>;
    close(opts?: {
        emitEvent?: boolean;
    }): Promise<boolean>;
    setSplitPaneWhen(value: SplitPaneShowWhen): Promise<void>;
    toggleSplitPaneShow(event?: Event): Promise<void>;
    executeAction(event: Event, item: MenuItem): Promise<void>;
    onSwipeRight(event: any): boolean;
    protected markAsLoaded(opts?: {
        emitEvent?: boolean;
    }): void;
    protected markAsLoading(opts?: {
        emitEvent?: boolean;
    }): void;
    protected detectChanges(): void;
    protected markForCheck(): void;
    protected togglePinned(event: Event, item: IMenuItem): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuComponent, [null, null, null, null, null, null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MenuComponent, "app-menu", never, { "id": { "alias": "id"; "required": false; }; "menuId": { "alias": "menuId"; "required": false; }; "side": { "alias": "side"; "required": false; }; "contentId": { "alias": "contentId"; "required": false; }; "logo": { "alias": "logo"; "required": false; }; "appName": { "alias": "appName"; "required": false; }; "rxStrategy": { "alias": "rxStrategy"; "required": false; }; "appVersion": { "alias": "appVersion"; "required": false; }; }, {}, never, ["*", "[headerBottomRight]"], false, never>;
}
