import { AfterViewInit, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { MenuService } from '../menu.service';
import { ActivatedRoute, Router } from '@angular/router';
import { AlertController, NavController } from '@ionic/angular';
import { TranslateService } from '@ngx-translate/core';
import { Subject } from 'rxjs';
import { MatTabGroup } from '@angular/material/tabs';
import { AppTabEditor } from '../../form/entity/tab-editor.class';
import * as i0 from "@angular/core";
export declare class MenuTestingPage extends AppTabEditor implements OnInit, OnDestroy, AfterViewInit {
    protected menuService: MenuService;
    protected logPrefix: string;
    protected childPath: string;
    protected thirdTabTitle: string;
    protected parentPath: string;
    protected path: string;
    protected showOtherLinks: boolean;
    protected showThirdTab: boolean;
    protected $title: Subject<string>;
    protected $secondTabTitle: Subject<string>;
    protected _subSelectedTabIndex: number;
    subTabCount: number;
    set subSelectedTabIndex(value: number);
    get subSelectedTabIndex(): number;
    readonly subSelectedTabIndexChange: EventEmitter<number>;
    subTabGroup: MatTabGroup;
    protected set title(value: string);
    protected set secondTabTitle(value: string);
    constructor(route: ActivatedRoute, // Modal editor give 'null'
    router: Router, navController: NavController, alertCtrl: AlertController, translate: TranslateService, menuService: MenuService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    load(id?: number, options?: any): Promise<void>;
    get isNewData(): boolean;
    reload(): Promise<void>;
    save(event: Event | undefined, options: any): Promise<boolean>;
    changeTitle(event?: UIEvent): void;
    changeSecondTabTitle(event?: UIEvent): void;
    addSubMenuItem(event?: UIEvent): void;
    addOutsideRouteSubMenuItem(event?: UIEvent, pinned?: boolean): void;
    protected enableMenu(value: boolean): void;
    protected toggleSplitPaneWhen(): void;
    protected initSubMenu(): Promise<void>;
    protected getFirstInvalidTabIndex(): number;
    protected getDefaultTitle(): string;
    protected computeTitle(): Promise<string>;
    setSubSelectedTabIndex(value: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuTestingPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MenuTestingPage, "app-testing-menu", never, { "subSelectedTabIndex": { "alias": "subSelectedTabIndex"; "required": false; }; }, { "subSelectedTabIndexChange": "subSelectedTabIndexChange"; }, never, never, false, never>;
}
