import { EventEmitter, OnInit } from '@angular/core';
import { AsyncValidatorFn, UntypedFormBuilder, UntypedFormGroup, ValidatorFn } from '@angular/forms';
import { AccountService, RegisterData } from '../services/account.service';
import { referentialToString } from '../services/model/referential.model';
import { Subscription } from 'rxjs';
import { AccountValidatorService } from '../services/validator/account.validator';
import { FormFieldDefinition } from '../../shared/form/field.model';
import { LocalSettingsService } from '../services/local-settings.service';
import { Environment } from '../../../environments/environment.class';
import { MatAutocompleteConfigHolder } from '../../shared/material/autocomplete/material.autocomplete.config';
import * as i0 from "@angular/core";
export declare class RegisterForm implements OnInit {
    private accountService;
    private accountValidatorService;
    formBuilder: UntypedFormBuilder;
    protected environment: Environment;
    protected settings?: LocalSettingsService;
    protected debug: boolean;
    autocompleteHelper: MatAutocompleteConfigHolder;
    additionalFields: FormFieldDefinition[];
    form: UntypedFormGroup;
    forms: UntypedFormGroup[];
    subscriptions: Subscription[];
    error: string;
    sending: boolean;
    showPwd: boolean;
    showConfirmPwd: boolean;
    private stepper;
    onCancel: EventEmitter<any>;
    onSubmit: EventEmitter<RegisterData>;
    constructor(accountService: AccountService, accountValidatorService: AccountValidatorService, formBuilder: UntypedFormBuilder, environment: Environment, settings?: LocalSettingsService);
    ngOnInit(): void;
    get value(): RegisterData;
    get valid(): boolean;
    isEnd(): boolean;
    isBeginning(): boolean;
    slidePrev(): void;
    slideNext(event?: Event): void;
    equalsValidator(otherControlName: string): ValidatorFn;
    emailAvailability(accountService: AccountService): AsyncValidatorFn;
    cancel(): void;
    doSubmit(event?: any): void;
    referentialToString: typeof referentialToString;
    markAsTouched(): void;
    disable(): void;
    enable(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<RegisterForm, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RegisterForm, "app-register-form", never, {}, { "onCancel": "onCancel"; "onSubmit": "onSubmit"; }, never, never, false, never>;
}
