import { InjectionToken } from '@angular/core';
import { Configuration } from './model/config.model';
import { Storage } from '@ionic/storage-angular';
import { Observable } from 'rxjs';
import { GraphqlService } from '../graphql/graphql.service';
import { FormFieldDefinition, FormFieldDefinitionMap } from '../../shared/form/field.model';
import { FileService } from '../../shared/file/file.service';
import { NetworkService } from './network.service';
import { Platform, ToastController } from '@ionic/angular';
import { ShowToastOptions } from '../../shared/toast/toasts';
import { TranslateService } from '@ngx-translate/core';
import { EntityServiceLoadOptions, IEntityService } from '../../shared/services/entity-service.class';
import { Environment } from '../../../environments/environment.class';
import { BaseGraphqlService } from './base-graphql-service.class';
import { IStartableService } from '../../shared/services/startable-service.class';
import { AccountService } from './account.service';
import * as i0 from "@angular/core";
export declare const ConfigFragments: {
    config: import("apollo-angular").TypedDocumentNode<unknown, unknown>;
};
export declare const APP_CONFIG_OPTIONS: InjectionToken<FormFieldDefinitionMap>;
export declare class ConfigService extends BaseGraphqlService<Configuration, any, number, Configuration> implements IEntityService<Configuration>, IStartableService<Configuration> {
    protected platform: Platform;
    protected graphql: GraphqlService;
    protected storage: Storage;
    protected network: NetworkService;
    protected file: FileService;
    protected toastController: ToastController;
    protected translate: TranslateService;
    protected accountService: AccountService;
    protected environment: Environment;
    private _optionDefs;
    private $data;
    get config(): Observable<Configuration>;
    constructor(platform: Platform, graphql: GraphqlService, storage: Storage, network: NetworkService, file: FileService, toastController: ToastController, translate: TranslateService, accountService: AccountService, environment: Environment, defaultOptionsMap: FormFieldDefinitionMap);
    protected ngOnStart(): Promise<Configuration>;
    loadDefault(opts?: EntityServiceLoadOptions): Promise<Configuration>;
    load(id: number, opts?: EntityServiceLoadOptions & {
        query?: any;
        variables?: any;
    }): Promise<Configuration>;
    canUserWrite(data: Configuration): boolean;
    /**
     * Save a configuration
     *
     * @param config
     */
    save(config: Configuration): Promise<Configuration>;
    getCacheStatistics(): Promise<string>;
    clearCache(opts?: {
        cacheName?: string;
    }): Promise<true>;
    delete(data: Configuration): Promise<any>;
    listenChanges(id: number): Observable<Configuration | undefined>;
    get optionDefs(): FormFieldDefinition[];
    protected copyIdAndUpdateDate(source: Configuration | undefined, target: Configuration): void;
    private loadOrRestoreLocally;
    private restoreLocally;
    private storeLocally;
    protected showToast(opts: ShowToastOptions): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfigService, [null, null, null, null, null, null, null, null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ConfigService>;
}
