import { FormErrors } from '../../shared/forms';
export interface AppError {
    code?: number;
    message?: string;
}
export interface AppErrorWithDetails extends AppError {
    details: AppError & {
        errors?: FormErrors;
    };
}
export declare interface ServiceError {
    code: number;
    message: string;
    reject?: (err: any) => void;
}
export declare const ErrorCodes: {
    UNKNOWN_ERROR: number;
    LOAD_ACCOUNT_ERROR: number;
    BAD_PASSWORD: number;
    UNKNOWN_ACCOUNT_EMAIL: number;
    EMAIL_ALREADY_REGISTERED: number;
    UNREACHABLE_NETWORK_ERROR: number;
    UNKNOWN_NETWORK_ERROR: number;
    SENT_CONFIRMATION_EMAIL_FAILED: number;
    CONFIRM_EMAIL_FAILED: number;
    SAVE_ACCOUNT_ERROR: number;
    ACCOUNT_NOT_EXISTS: number;
    SAVE_SETTINGS_ERROR: number;
    SUBSCRIBE_ACCOUNT_ERROR: number;
    ENTITY_STORAGE_MIGRATION_FAILED: number;
    LOAD_DATA_ERROR: number;
    SAVE_DATA_ERROR: number;
    DELETE_DATA_ERROR: number;
    SUBSCRIBE_DATA_ERROR: number;
    LOAD_PERSONS_ERROR: number;
    DATA_NOT_FOUND_ERROR: number;
    TABLE_INVALID_ROW_ERROR: number;
    TABLE_READ_ONLY: number;
    UNAUTHORIZED: number;
    INTERNAL_SERVER_ERROR: number;
    AUTH_CHALLENGE_ERROR: number;
    AUTH_SERVER_ERROR: number;
    AUTH_SEND_RESET_PASSWORD_EMAIL_ERROR: number;
    AUTH_RESET_PUBKEY_ERROR: number;
    AUTH_UPDATE_PUBKEY_ERROR: number;
    LOAD_CONFIG_ERROR: number;
    SAVE_CONFIG_ERROR: number;
    LOAD_TRASH_ENTITY_ERROR: number;
    DELETE_TRASH_ENTITY_ERROR: number;
};
export declare const ServerErrorCodes: {
    BAD_REQUEST: number;
    UNAUTHORIZED: number;
    FORBIDDEN: number;
    NOT_FOUND: number;
    INTERNAL_SERVER_ERROR: number;
    DATA_LOCKED: number;
    BAD_UPDATE_DATE: number;
    DENY_DELETION: number;
    DATA_NOT_UNIQUE: number;
    INVALID_EMAIL_CONFIRMATION: number;
    INVALID_QUERY_VARIABLES: number;
    ACCOUNT_ALREADY_EXISTS: number;
    BAD_APP_VERSION: number;
};
