import { Moment } from 'moment';
import { FormFieldDefinition } from '../../../shared/form/field.model';
import { Entity, EntityAsObjectOptions, IEntity } from './entity.model';
import { Department } from './department.model';
import { PropertyMap } from '../../../shared/types';
export declare class Software<T extends Software<any> = Software<any>> extends Entity<T, number> implements IEntity<T, number> {
    static fromObject: (source: any, opts?: any) => Software;
    label: string;
    name: string;
    description: string;
    comments: string;
    creationDate: Date | Moment;
    statusId: number;
    properties: PropertyMap;
    constructor(__typename?: string);
    asObject(options?: EntityAsObjectOptions): any;
    fromObject(source: any): void;
}
export declare class Configuration extends Software<Configuration> {
    static fromObject: (source: any, opts?: any) => Configuration;
    smallLogo: string;
    largeLogo: string;
    backgroundImages: string[];
    partners: Department[];
    constructor();
    clone(): Configuration;
    copy(target: Configuration): Configuration;
    asObject(options?: EntityAsObjectOptions): any;
    fromObject(source: any): void;
    getPropertyAsBoolean(definition: FormFieldDefinition): boolean;
    getPropertyAsInt(definition: FormFieldDefinition): number;
    getPropertyAsNumbers(definition: FormFieldDefinition): number[];
    getPropertyAsStrings(definition: FormFieldDefinition): string[];
    getProperty<T = string>(definition: FormFieldDefinition): T;
    hasProperty<T = string>(definition: FormFieldDefinition): boolean;
}
