import { Entity } from './entity.model';
declare type Constructor<T = any> = new (...args: any[]) => T;
export declare class EntityClasses {
    static CLASSES_BY_NAME: Map<string, Constructor<any>>;
    static register(typename: string, entityClass: Constructor): void;
    static get<T extends Entity<T>>(entityName: string): Constructor;
    static fromObject<T extends Entity<T>>(value: any, opts?: {
        [key: string]: any;
        typename?: string;
        entityName?: string;
    }): T;
}
export declare function EntityClass(opts: {
    typename: string;
    fromObjectReuseStrategy?: 'default' | 'clone';
}): <T extends Constructor<any>>(constructor: T) => T;
export {};
