import { Cloneable, Entity, EntityAsObjectOptions } from './entity.model';
import { NodeFeature } from './node-feature.model';
export declare class Peer extends Entity<Peer> implements Cloneable<Peer> {
    static fromObject: (source: any, opts?: any) => Peer;
    static parseUrl(peerUrl: string): Peer;
    static path(peer: Peer, ...paths: string[]): string;
    static equals(p1: Peer, p2: Peer): boolean;
    static countAllFeatures(peers: Peer[]): number;
    dns: string;
    ipv4: string;
    ipv6: string;
    port: number;
    useSsl: boolean;
    pubkey: string;
    path?: string;
    favicon: string;
    status: 'UP' | 'DOWN';
    softwareName: string;
    softwareVersion: string;
    label: string;
    name: string;
    registrationUri?: string;
    registrationManager?: string;
    features?: NodeFeature[];
    constructor();
    asObject(options?: EntityAsObjectOptions): any;
    fromObject(source: any): void;
    equals(other: Peer): boolean;
    /**
     * Return the peer URL (without trailing slash)
     */
    get url(): string;
    get hostAndPort(): string;
    get reachable(): boolean;
}
