import { Moment } from 'moment';
import { ReferentialAsObjectOptions } from './referential.model';
import { Entity } from './entity.model';
import { Department } from './department.model';
export type UserProfileLabel = 'ADMIN' | 'USER' | 'SUPERVISOR' | 'GUEST';
export declare const PRIORITIZED_AUTHORITIES: Readonly<UserProfileLabel[]>;
export declare class Person<T extends Person<any> = Person<any>> extends Entity<T, number, ReferentialAsObjectOptions> {
    static fromObject: (source: any, opts?: any) => Person;
    firstName: string;
    lastName: string;
    email: string;
    pubkey: string;
    avatar: string;
    creationDate: Date | Moment;
    statusId: number;
    department: Department;
    username: string;
    usernameExtranet: string;
    profiles: string[];
    mainProfile: string;
    constructor(__typename?: string);
    asObject(opts?: ReferentialAsObjectOptions): any;
    fromObject(source: any): void;
    equals(other: T): boolean;
}
export declare class PersonUtils {
    static getMainProfile(profiles?: string[]): UserProfileLabel;
    static getMainProfileIndex(profiles?: string[]): number;
    static hasUpperOrEqualsProfile(actualProfiles: string[], expectedProfile: UserProfileLabel): boolean;
    static personToString(obj: Person, opts?: {
        withDepartment?: boolean;
    }): string;
    static personsToString(data: Person[], separator?: string, opts?: {
        withDepartment?: boolean;
    }): string;
    static roleToProfile(role: string, defaultProfile?: UserProfileLabel): UserProfileLabel;
}
