import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Peer } from './model/peer.model';
import { NodeFeature } from './model/node-feature.model';
import { ConnectionStatus, ConnectionType } from '@capacitor/network';
import { Observable } from 'rxjs';
export interface NodeInfo {
    softwareName: string;
    softwareVersion: string;
    nodeLabel?: string;
    nodeName?: string;
    features?: NodeFeature[];
}
export interface AppManifest {
    manifest_version: number;
    name: string;
    version: string;
    start_url: string;
    short_name?: string;
    description?: string;
    version_name?: string;
    author?: string;
    default_locale?: string;
    icons?: any | any[];
    background_color?: string;
    theme_color?: string;
    display?: string;
}
export declare class NetworkUtils {
    static getNodeInfo(http: HttpClient, peer: string | Peer, opts?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        responseType?: 'json';
    }): Promise<NodeInfo>;
    static isPluginAvailable(): boolean;
    static statusChanges(): Observable<ConnectionStatus>;
    static getConnectionType(): Promise<ConnectionType>;
}
