import { UntypedFormBuilder } from '@angular/forms';
import { Account } from '../model/account.model';
import { AccountService } from '../account.service';
import { UserSettingsValidatorService } from './user-settings.validator';
import { PersonValidatorOptions, PersonValidatorService } from '../../../admin/services/validator/person.validator';
import { TranslateService } from '@ngx-translate/core';
import * as i0 from "@angular/core";
export interface AccountValidatorOptions extends PersonValidatorOptions {
    withSettings?: boolean;
    withTokens?: boolean;
}
export declare class AccountValidatorService<T extends Account = Account, O extends AccountValidatorOptions = AccountValidatorOptions> extends PersonValidatorService<T, O> {
    protected formBuilder: UntypedFormBuilder;
    protected translate: TranslateService;
    protected accountService: AccountService;
    protected userSettingsValidatorService: UserSettingsValidatorService;
    constructor(formBuilder: UntypedFormBuilder, translate: TranslateService, accountService: AccountService, userSettingsValidatorService: UserSettingsValidatorService);
    getFormGroupConfig(data?: T, opts?: O): {
        [key: string]: any[];
    };
    protected fillDefaultOptions(opts?: O): O;
    static ɵfac: i0.ɵɵFactoryDeclaration<AccountValidatorService<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AccountValidatorService<any, any>>;
}
