import { ValidatorService } from '@e-is/ngx-material-table';
import { AbstractControl, UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { IValidatorService } from '../../../shared/services/validator-service.class';
import { TranslateService } from '@ngx-translate/core';
import { FormErrors } from '../../../shared/forms';
import * as i0 from "@angular/core";
export declare abstract class AppValidatorService<T = any, O = any> extends ValidatorService implements IValidatorService<T> {
    protected formBuilder: UntypedFormBuilder;
    protected translate?: TranslateService;
    protected constructor(formBuilder: UntypedFormBuilder, translate?: TranslateService);
    getRowValidator(): UntypedFormGroup;
    getFormGroup(data?: T, opts?: O): UntypedFormGroup;
    getFormGroupConfig(data?: T, opts?: O): {
        [key: string]: any[];
    };
    getI18nFormErrors(control: AbstractControl): string[];
    getI18nErrors(errors: FormErrors): string[];
    protected getI18nError(errorKey: string, errorContent?: any): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppValidatorService<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AppValidatorService<any, any>, never, never, {}, {}, never, never, false, never>;
}
