import { AbstractControl, UntypedFormBuilder, UntypedFormGroup, ValidationErrors } from '@angular/forms';
import { LocalSettings } from '../model/settings.model';
import { NetworkService } from '../network.service';
import { AppValidatorService } from './base.validator.class';
import { PropertyValidator } from '../../form/properties/property.validator';
import { FormFieldDefinition } from '../../../shared/form/field.model';
import * as i0 from "@angular/core";
export declare class LocalSettingsValidatorService extends AppValidatorService<LocalSettings> {
    private propertyValidator;
    private networkService;
    constructor(formBuilder: UntypedFormBuilder, propertyValidator: PropertyValidator, networkService: NetworkService);
    getFormGroup(data?: LocalSettings, opts?: {
        definitions?: FormFieldDefinition[];
    }): UntypedFormGroup;
    protected peerAlive(peerUrlControl: AbstractControl): Promise<ValidationErrors | null>;
    static ɵfac: i0.ɵɵFactoryDeclaration<LocalSettingsValidatorService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<LocalSettingsValidatorService>;
}
