import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { AsyncTableElement, TableElement } from '@e-is/ngx-material-table';
import { MatColumnDef, MatTable } from '@angular/material/table';
import { MatMenuTrigger } from '@angular/material/menu';
import * as i0 from "@angular/core";
export declare class ActionsColumnComponent<T extends TableElement<any> | AsyncTableElement<any> = TableElement<any>> implements OnInit, OnDestroy {
    private table;
    private cd;
    columnDef: MatColumnDef;
    matMenuTrigger: MatMenuTrigger;
    matColumnDef: string;
    style: 'table' | 'mat-table';
    stickyEnd: boolean;
    canCancel: boolean;
    canConfirm: boolean;
    canDelete: boolean;
    canBackward: boolean;
    canForward: boolean;
    canConfirmAndAdd: boolean;
    dirtyIcon: boolean | string;
    optionsTitle: string;
    classList: string;
    cellTemplateStart: TemplateRef<{
        $implicit: T;
    }>;
    cellTemplate: TemplateRef<{
        $implicit: T;
    }>;
    optionsClick: EventEmitter<Event>;
    cancelOrDeleteClick: EventEmitter<{
        event: Event;
        row: T;
    }>;
    confirmEditCreateClick: EventEmitter<{
        event: Event;
        row: T;
    }>;
    confirmAndAddClick: EventEmitter<{
        event: Event;
        row: T;
    }>;
    backward: EventEmitter<{
        event: Event;
        row: T;
    }>;
    forward: EventEmitter<{
        event: Event;
        row: T;
    }>;
    constructor(table: MatTable<any>, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ActionsColumnComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ActionsColumnComponent<any>, "app-actions-column", never, { "matColumnDef": { "alias": "matColumnDef"; "required": false; }; "style": { "alias": "style"; "required": false; }; "stickyEnd": { "alias": "stickyEnd"; "required": false; }; "canCancel": { "alias": "canCancel"; "required": false; }; "canConfirm": { "alias": "canConfirm"; "required": false; }; "canDelete": { "alias": "canDelete"; "required": false; }; "canBackward": { "alias": "canBackward"; "required": false; }; "canForward": { "alias": "canForward"; "required": false; }; "canConfirmAndAdd": { "alias": "canConfirmAndAdd"; "required": false; }; "dirtyIcon": { "alias": "dirtyIcon"; "required": false; }; "optionsTitle": { "alias": "optionsTitle"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "cellTemplateStart": { "alias": "cellTemplateStart"; "required": false; }; "cellTemplate": { "alias": "cellTemplate"; "required": false; }; }, { "optionsClick": "optionsClick"; "cancelOrDeleteClick": "cancelOrDeleteClick"; "confirmEditCreateClick": "confirmEditCreateClick"; "confirmAndAddClick": "confirmAndAddClick"; "backward": "backward"; "forward": "forward"; }, never, ["[matHeader]", "[matFooter]", "[matHeader]", "[matFooter]"], false, never>;
    static ngAcceptInputType_stickyEnd: unknown;
    static ngAcceptInputType_canCancel: unknown;
    static ngAcceptInputType_canConfirm: unknown;
    static ngAcceptInputType_canDelete: unknown;
    static ngAcceptInputType_canBackward: unknown;
    static ngAcceptInputType_canForward: unknown;
    static ngAcceptInputType_canConfirmAndAdd: unknown;
}
