import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { AsyncTableElement, TableElement } from '@e-is/ngx-material-table';
import { MatColumnDef, MatTable } from '@angular/material/table';
import { MatMenuTrigger } from '@angular/material/menu';
import { AppTable } from '../table.class';
import { AppAsyncTable } from '../async-table.class';
import { Subject, Subscription } from 'rxjs';
import * as i0 from "@angular/core";
export declare class NavActionsColumnComponent<T extends TableElement<any> | AsyncTableElement<any> = TableElement<any>> implements OnInit, OnDestroy {
    private matTable;
    private cd;
    _subscription: Subscription;
    _forwardEventSubject: Subject<{
        event: Event;
        row: T;
    }>;
    _backwardEventSubject: Subject<{
        event: Event;
        row: T;
    }>;
    columnDef: MatColumnDef;
    matMenuTrigger: MatMenuTrigger;
    appTable: AppTable<any> | AppAsyncTable<any>;
    matColumnDef: string;
    style: 'table' | 'mat-table';
    stickyEnd: boolean;
    showPending: boolean;
    dirtyIcon: boolean | string;
    optionsTitle: string;
    classList: string;
    cellTemplate: TemplateRef<{
        $implicit: T;
    }>;
    throttleTime: number;
    optionsClick: EventEmitter<Event>;
    constructor(matTable: MatTable<any>, cd: ChangeDetectorRef, appTable: AppTable<any>, appAsyncTable: AppAsyncTable<any>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    protected cancelOrDelete(event: Event, row: T): void;
    protected confirmAndForward(event: Event, row: T): void;
    protected confirmAndBackward(event: Event, row: T): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NavActionsColumnComponent<any>, [null, null, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NavActionsColumnComponent<any>, "app-nav-actions-column", never, { "appTable": { "alias": "appTable"; "required": false; }; "matColumnDef": { "alias": "matColumnDef"; "required": false; }; "style": { "alias": "style"; "required": false; }; "stickyEnd": { "alias": "stickyEnd"; "required": false; }; "showPending": { "alias": "showPending"; "required": false; }; "dirtyIcon": { "alias": "dirtyIcon"; "required": false; }; "optionsTitle": { "alias": "optionsTitle"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "cellTemplate": { "alias": "cellTemplate"; "required": false; }; "throttleTime": { "alias": "throttleTime"; "required": false; }; }, { "optionsClick": "optionsClick"; }, never, ["[matHeader]", "[matFooter]", "[matHeader]", "[matFooter]"], false, never>;
    static ngAcceptInputType_stickyEnd: unknown;
    static ngAcceptInputType_showPending: unknown;
}
