import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { ThemePalette } from '@angular/material/core';
import { PredefinedColors } from '@ionic/core';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { AppFloatLabelType, FormFieldDefinition } from '../../../shared/form/field.model';
import { MatColumnDef, MatTable } from '@angular/material/table';
import { AsyncTableElement, TableElement } from '@e-is/ngx-material-table';
import * as i0 from "@angular/core";
export declare class AppRowField implements OnInit, OnDestroy {
    protected cd: ChangeDetectorRef;
    matTable: MatTable<any>;
    columnDef: MatColumnDef;
    name: string;
    definition: FormFieldDefinition;
    definitionFn: (row: TableElement<any> | AsyncTableElement<any>) => FormFieldDefinition;
    headerI18n: string;
    sortable: boolean;
    resizable: boolean;
    required: boolean;
    readonly: boolean;
    sticky: boolean;
    draggable: boolean;
    disabled: boolean;
    placeholder: string;
    compact: boolean;
    floatLabel: AppFloatLabelType;
    appearance: MatFormFieldAppearance;
    tabindex: number;
    autofocus: boolean;
    clearable: boolean;
    chipColor: ThemePalette | PredefinedColors;
    classList: string;
    debug: boolean;
    protected logPrefix: string;
    constructor(cd: ChangeDetectorRef, matTable: MatTable<any>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppRowField, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppRowField, "app-row-field", never, { "name": { "alias": "name"; "required": false; }; "definition": { "alias": "definition"; "required": false; }; "definitionFn": { "alias": "definitionFn"; "required": false; }; "headerI18n": { "alias": "headerI18n"; "required": false; }; "sortable": { "alias": "sortable"; "required": false; }; "resizable": { "alias": "resizable"; "required": false; }; "required": { "alias": "required"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "sticky": { "alias": "sticky"; "required": false; }; "draggable": { "alias": "draggable"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "chipColor": { "alias": "chipColor"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "debug": { "alias": "debug"; "required": false; }; }, {}, never, never, false, never>;
}
