import { Injector, OnInit } from '@angular/core';
import { ValidatorService } from '@e-is/ngx-material-table';
import { EntitiesTableDataSourceConfig } from './entities-table-datasource.class';
import { AppTable } from './table.class';
import { IEntity } from '../services/model/entity.model';
import { InMemoryEntitiesService } from '../../shared/services/memory-entity-service.class';
import * as i0 from "@angular/core";
export declare abstract class AppInMemoryTable<T extends IEntity<T, ID>, F = any, ID = number> extends AppTable<T, F, ID> implements OnInit {
    protected columns: string[];
    protected dataType: new () => T;
    protected memoryDataService: InMemoryEntitiesService<T, F, ID>;
    protected validatorService: ValidatorService;
    canEdit: boolean;
    canDelete: boolean;
    set value(data: T[]);
    get value(): T[];
    protected constructor(injector: Injector, columns: string[], dataType: new () => T, memoryDataService: InMemoryEntitiesService<T, F, ID>, validatorService: ValidatorService, options?: EntitiesTableDataSourceConfig<T, ID>, filter?: F);
    ngOnInit(): void;
    setValue(value: T[], opts?: {
        emitEvent?: boolean;
    }): void;
    protected equals(t1: T, t2: T): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppInMemoryTable<any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AppInMemoryTable<any, any, any>, never, never, { "canEdit": { "alias": "canEdit"; "required": false; }; "canDelete": { "alias": "canDelete"; "required": false; }; }, {}, never, never, false, never>;
}
