import { Subject, Subscription } from 'rxjs';
export declare const SETTINGS_DISPLAY_COLUMNS = "displayColumns";
export declare const SETTINGS_SORTED_COLUMN = "sortedColumn";
export declare const SETTINGS_FILTER = "filter";
export declare const SETTINGS_PAGE_SIZE = "pageSize";
export declare const SETTINGS_COMPACT_ROWS = "compactRows";
export declare const DEFAULT_PAGE_SIZE = 20;
export declare const DEFAULT_PAGE_SIZE_OPTIONS: number[];
export declare const RESERVED_START_COLUMNS: string[];
export declare const RESERVED_END_COLUMNS: string[];
export declare const DEFAULT_REQUIRED_COLUMNS: string[];
export declare const TABLE_SETTINGS_ENUM: {
    FILTER_KEY: string;
    COMPACT_ROWS_KEY: string;
};
export declare class CellValueChangeListener {
    subject: Subject<any>;
    subscription: Subscription;
    formPath: string;
    emitInitialValue: boolean;
}
export interface IModalDetailOptions<T = any> {
    isNew: boolean;
    data: T;
    disabled: boolean;
    onDelete?: (event: Event, data: T) => Promise<boolean>;
}
export type SaveActionType = 'delete' | 'sort' | 'filter';
export interface IEntitiesTableDataSource<R> {
    getRows(): R[];
}
