import { ChangeDetectorRef, OnDestroy, PipeTransform } from '@angular/core';
import { SelectionModel } from '@angular/cdk/collections';
import { AbstractSelectionModelPipe } from '../../shared/pipes/selection.pipes';
import { AppTable } from './table.class';
import { Subscription } from 'rxjs';
import { AppAsyncTable } from './async-table.class';
import * as i0 from "@angular/core";
export type AppTableRowCountProperty = 'visibleRowCount' | 'totalRowCount';
export declare abstract class AbstractTableSelectionPipe<R, O, T extends AppTable<any> | AppAsyncTable<any> = AppTable<any> | AppAsyncTable<any>> extends AbstractSelectionModelPipe<any, R, O> {
    private _onRowsChanges;
    protected constructor(_ref: ChangeDetectorRef);
    transform(selectionOrTable: SelectionModel<any> | T, tableOrOpts?: T | O, opts?: O): R;
    protected _subscribe(selection: SelectionModel<any>, table?: T, opts?: O): Subscription;
    protected _dispose(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractTableSelectionPipe<any, any, any>, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<AbstractTableSelectionPipe<any, any, any>, "abstract-table-selection", false>;
}
export declare class IsAllSelectedPipe extends AbstractTableSelectionPipe<boolean, AppTableRowCountProperty> implements PipeTransform, OnDestroy {
    constructor(_ref: ChangeDetectorRef);
    protected _transform(selection: SelectionModel<any>, table: AppTable<any>, countPropertyName?: AppTableRowCountProperty): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<IsAllSelectedPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IsAllSelectedPipe, "isAllSelected", false>;
}
export declare class IsNotAllSelectedPipe extends IsAllSelectedPipe implements PipeTransform, OnDestroy {
    constructor(_ref: ChangeDetectorRef);
    protected _transform(selection: SelectionModel<any>, table: AppTable<any>, countPropertyName?: AppTableRowCountProperty): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<IsNotAllSelectedPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IsNotAllSelectedPipe, "isNotAllSelected", false>;
}
