import { AfterViewInit, Injector, OnDestroy, OnInit } from '@angular/core';
import { AppTable } from '../table.class';
import { Referential } from '../../services/model/referential.model';
import { IonInfiniteScroll } from '@ionic/angular';
import { InMemoryEntitiesService } from '../../../shared/services/memory-entity-service.class';
import { AppValidatorService } from '../../services/validator/base.validator.class';
import { AbstractControl, UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { ReferentialFilter } from '../../services/testing/referential-filter.model';
import { MatExpansionPanel } from '@angular/material/expansion';
import * as i0 from "@angular/core";
export declare class Table2TestPage extends AppTable<Referential, ReferentialFilter> implements OnInit, OnDestroy, AfterViewInit {
    protected validatorService: AppValidatorService;
    protected formBuilder: UntypedFormBuilder;
    static readonly maxRowCount = 100;
    canEdit: boolean;
    data: Referential[];
    filterForm: UntypedFormGroup;
    filterCriteriaCount: number;
    rowHeight: number;
    enableInfiniteScroll: boolean;
    checkBoxSelection: boolean;
    resizable: boolean;
    filterPanelFloating: boolean;
    sticky: boolean;
    stickyEnd: boolean;
    get hasMoreData(): boolean;
    filterExpansionPanel: MatExpansionPanel;
    infiniteScroll: IonInfiniteScroll;
    get dataService(): InMemoryEntitiesService<Referential>;
    constructor(injector: Injector, validatorService: AppValidatorService, formBuilder: UntypedFormBuilder);
    ngOnInit(): void;
    ngAfterViewInit(): Promise<void>;
    ngOnDestroy(): void;
    protected restoreFilter(): Promise<void>;
    load(): Promise<void>;
    fetchMore(event: any): Promise<void>;
    save(opts?: {
        keepEditing?: boolean;
    }): Promise<boolean>;
    clearControlValue(event: Event, formControl: AbstractControl): boolean;
    toggleFilterPanelFloating(): void;
    applyFilterAndClosePanel(event?: Event): void;
    closeFilterPanel(): void;
    resetFilter(_?: Event): void;
    protected generateData(offset?: number, size?: number): Referential[];
    static ɵfac: i0.ɵɵFactoryDeclaration<Table2TestPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Table2TestPage, "app-table2-testing", never, { "filterPanelFloating": { "alias": "filterPanelFloating"; "required": false; }; "sticky": { "alias": "sticky"; "required": false; }; "stickyEnd": { "alias": "stickyEnd"; "required": false; }; }, {}, never, ["[suffix]"], false, never>;
}
