import { AlertController } from '@ionic/angular';
import { TranslateService } from '@ngx-translate/core';
export declare class Alerts {
    /**
     * Ask the user to save before leaving. If return undefined: user has cancelled
     * <p>
     *   from a routed page, prefer using ComponentDirtyGuard
     *
     * @param alertCtrl
     * @param translate
     * @param event
     */
    static askSaveBeforeLeave(alertCtrl: AlertController, translate: TranslateService, event?: Event): Promise<boolean | undefined>;
    /**
     * Ask the user to conform an action. If return undefined: user has cancelled
     *
     * @param alertCtrl
     * @param translate
     * @param immediate is action has an immediate effect ?
     * @param event
     * @param interpolateParams
     */
    static askActionConfirmation(alertCtrl: AlertController, translate: TranslateService, immediate?: boolean, event?: Event, interpolateParams?: any): Promise<boolean | undefined>;
    /**
     * Ask the user to confirm. If return undefined: user has cancelled
     *
     * @pram messageKey i18n message key
     * @param messageKey
     * @param alertCtrl
     * @param translate
     * @param event
     * @param interpolateParams
     */
    static askConfirmation(messageKey: string, alertCtrl: AlertController, translate: TranslateService, event?: Event, interpolateParams?: any): Promise<boolean | undefined>;
    /**
     * Ask the user to save before leaving. If return undefined: user has cancelled
     *
     * @param alertCtrl
     * @param translate
     * @param event
     * @param interpolateParams
     */
    static askDeleteConfirmation(alertCtrl: AlertController, translate: TranslateService, event?: Event, interpolateParams?: any): Promise<boolean | undefined>;
    static askSaveBeforeAction(alertCtrl: AlertController, translate: TranslateService, opts?: {
        valid?: boolean;
        validMessageI18n?: string;
        invalidMessageI18n?: string;
    }, interpolateParams?: any): Promise<{
        confirmed: boolean;
        save: boolean;
    } | undefined>;
    static showError(messageKey: string, alertCtrl: AlertController, translate: TranslateService, opts?: {
        titleKey?: string;
    }, interpolateParams?: any): Promise<void>;
}
