import { Platform } from '@ionic/angular';
import { AudioManagement, AudioMode } from '@awesome-cordova-plugins/audio-management/ngx';
import { StartableService } from '../services/startable-service.class';
import * as i0 from "@angular/core";
export type AudioType = 'html5' | 'native';
export interface Sound {
    assetId: string;
    assetPath: string;
    volume?: number;
    isUrl?: boolean;
    time?: number;
    audioChannelNum?: number;
    vibration?: number | number[];
}
export declare class AudioProvider extends StartableService<void> {
    protected platform: Platform;
    private audioManagement;
    private _audioType;
    private _audioMode;
    private _enableAudioManagment;
    private _assetPathPrefix;
    private _preloadedSounds;
    private _htmlAudioCache;
    constructor(platform: Platform, audioManagement: AudioManagement);
    protected ngOnStart(): Promise<void>;
    playBeepConfirm(): Promise<any>;
    playBeepError(): Promise<any>;
    playBeepNotification(): Promise<any>;
    playStartupSound(): Promise<any>;
    preload(sound: Sound): Promise<void>;
    play(assetId: string, opts?: {
        vibrate?: boolean;
        vibration?: number | number[];
    }): Promise<any>;
    unload(assetId: string): Promise<void>;
    /**
     *
     * @param duration Duration of the vibration in milliseconds.
     */
    vibrate(duration?: number | number[]): Promise<void>;
    setAudioMode(mode: AudioMode): Promise<void>;
    protected readAudioMode(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<AudioProvider, [null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AudioProvider>;
}
