import { Observable } from 'rxjs';
import { FileEvent } from '../upload-file/upload-file.model';
import { TranslateService } from '@ngx-translate/core';
import { DisplayFn } from '../form/field.model';
export declare class CsvUtils {
    static DEFAULT_SEPARATOR: string;
    static DEFAULT_ENCODING: string;
    static exportToFile(rows: object[], opts?: {
        filename?: string;
        headers?: string[];
        includedProperties?: string[];
        excludedProperties?: string[];
        formatters?: {
            [key: string]: DisplayFn;
        };
        separator?: string;
        encoding?: string;
        type?: string;
    }): void;
    static parseFile(file: File, opts?: {
        separator?: string;
        encoding?: string;
    }): Observable<FileEvent<string[][]>>;
    static parseCSV(body: string, opts?: {
        separator?: string;
        skipEmptyLine?: boolean;
    }): string[][];
    static getLocalizedSeparator(translate?: TranslateService, defaultSeparator?: string): string;
    static getLocalizedEncoding(translate: TranslateService, defaultEncoding?: string): string;
}
