import { FileEvent, UploadFile } from '../upload-file/upload-file.model';
import { UploadFilePopoverOptions } from '../upload-file/upload-file-popover.component';
import { PopoverController } from '@ionic/angular';
import { Observable } from 'rxjs';
import { OverlayEventDetail } from '@ionic/core';
export declare const MimeTypes: Readonly<{
    ANDROID_APK: "application/vnd.android.package-archive";
}>;
export declare class FilesUtils {
    static UTF8_BOM_CHAR: Uint8Array;
    static showUploadPopover<T>(popoverController: PopoverController, event: Event, opts: UploadFilePopoverOptions<T>): Promise<OverlayEventDetail<UploadFile<T>[]>>;
    static readAsText(file: File, encoding?: string): Observable<FileEvent<string>>;
    static writeTextToFile(content: string, opts?: {
        filename?: string;
        encoding?: string;
        type?: string;
    }): void;
    static downloadUri(uri: string, filename?: string): void;
    static getFilenameFromUri(uri: string): string;
}
