import { Observable } from 'rxjs';
import { FileEvent } from '../upload-file/upload-file.model';
export declare const IMAGE_DEFAULTS: {
    MAX_HEIGHT: number;
    MAX_WIDTH: number;
    THUMB_MAX_HEIGHT: number;
    THUMB_MAX_WIDTH: number;
};
export declare interface ImageResizeOptions {
    maxWidth?: number;
    maxHeight?: number;
    thumbnail?: boolean;
}
export declare class ImagesUtils {
    /**
     * Parse a string like `<path>|<credit>` into an object `{image, credit}`
     * @param file
     **/
    static getImageAndCredit(file: string): {
        image: string;
        credits: string;
    };
    /**
     * @param files
     * @deprecated Use getRandomImageWithCredit() instead
     **/
    static getRandomImage(files: string[]): string | undefined;
    static getRandomImageWithCredit(files: string[]): {
        image: string;
        credits: string;
    };
    static readAsDataURL(file: File, opts?: ImageResizeOptions): Observable<FileEvent<string>>;
    static readAndResizeFromUrl(fileUrl: string, opts?: ImageResizeOptions): Promise<string>;
    static resizeBase64(dataUrl: string, opts?: ImageResizeOptions): Promise<string>;
    protected static createImageOnLoadResizeFn(resolve: any, reject: any, opts?: ImageResizeOptions): (event: any) => void;
}
