import { PlatformService } from '../../core/services/platform.service';
import { Platform } from '@ionic/angular';
export declare class IPosition {
    latitude: number;
    longitude: number;
}
export declare abstract class GeolocationUtils {
    static isNotNilAndValid(position: IPosition, opts?: {
        debug?: boolean;
    }): boolean;
    static isNilOrInvalid(position: IPosition, opts?: {
        debug?: boolean;
    }): boolean;
    static computeDistanceInMiles(position1: IPosition, position2: IPosition): number;
    /**
     * Get the position by geo loc sensor
     */
    static getCurrentPosition(platform: PlatformService | Platform, options?: PositionOptions): Promise<IPosition>;
}
