import { InjectionToken } from '@angular/core';
import { EventManager } from '@angular/platform-browser';
import { Observable } from 'rxjs';
import { ModalController, Platform, PopoverController } from '@ionic/angular';
import { MatDialog } from '@angular/material/dialog';
import * as i0 from "@angular/core";
interface Options {
    element: any;
    elementName: string;
    description: string | undefined;
    keys: string;
    preventDefault: boolean;
}
export interface HotKeysConfig {
    /**
     * Shortcut to open the hotkeys help modal
     */
    openHelpModalShortcut: string;
    /**
     * Enable the hotkeys help modal
     */
    enableHelpModal: boolean;
}
export declare const APP_HOTKEYS_CONFIG: InjectionToken<Partial<HotKeysConfig>>;
export declare class Hotkeys {
    private eventManager;
    private dialog;
    private modalController;
    private popoverController;
    private _debug;
    private _id;
    private _hotkeys;
    private _document;
    private _defaults;
    private _dialogRef;
    private _config;
    readonly defaultControlKey: string;
    readonly defaultControlKeyName: string;
    get isHelpModalOpened(): boolean;
    constructor(platform: Platform, eventManager: EventManager, dialog: MatDialog, modalController: ModalController, popoverController: PopoverController, config?: Partial<HotKeysConfig>);
    addShortcut(options: Partial<Options>): Observable<KeyboardEvent>;
    toggleHelpModal(): void;
    openHelpModal(): void;
    closeHelpModal(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Hotkeys, [null, null, null, null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Hotkeys>;
}
export {};
