import { SortDirection } from '@angular/material/sort';
import { BehaviorSubject, Observable } from 'rxjs';
import { StartableService } from '../../../services/startable-service.class';
import { EntitiesServiceWatchOptions, IEntitiesService, LoadResult } from '../../../services/entity-service.class';
import { Platform } from '@ionic/angular';
import { Entity } from '../../../../core/services/model/entity.model';
import { Image } from '../../image.model';
import { EntityFilter } from '../../../../core/services/model/filter.model';
import * as i0 from "@angular/core";
export declare class ImageAttachment extends Entity<ImageAttachment> implements Image {
    static fromObject: (source: any, opts?: any) => ImageAttachment;
    dataUrl: string;
    url: string;
    title: string;
    fromObject(source: any, opts?: any): void;
}
export declare class ImageAttachmentFilter extends EntityFilter<ImageAttachmentFilter, ImageAttachment> {
    static fromObject: (source: any, opts?: any) => ImageAttachmentFilter;
}
export declare class ImageAttachmentService extends StartableService implements IEntitiesService<ImageAttachment, ImageAttachmentFilter> {
    protected platform: Platform;
    $images: BehaviorSubject<Partial<ImageAttachment>[]>;
    constructor(platform: Platform);
    protected ngOnStart(): Promise<any>;
    watchAll(offset: number, size: number, sortBy?: string, sortDirection?: SortDirection, filter?: ImageAttachmentFilter, opts?: EntitiesServiceWatchOptions & {
        query?: any;
    }): Observable<LoadResult<ImageAttachment>>;
    saveAll(entities: ImageAttachment[]): Promise<any[]>;
    deleteAll(entities: ImageAttachment[]): Promise<any>;
    asFilter(filter: any): ImageAttachmentFilter;
    static ɵfac: i0.ɵɵFactoryDeclaration<ImageAttachmentService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ImageAttachmentService>;
}
