import { PopoverController } from '@ionic/angular';
import { TranslateService } from '@ngx-translate/core';
import { StartableService } from '../services/startable-service.class';
import { Environment } from '../../../environments/environment.class';
import { PlatformService } from '../../core/services/platform.service';
import { LocalSettingsService } from '../../core/services/local-settings.service';
import { Image } from './image.model';
import { ImageOptions } from '@capacitor/camera';
import * as i0 from "@angular/core";
export declare class ImageService extends StartableService {
    protected platform: PlatformService;
    protected settings: LocalSettingsService;
    protected translate: TranslateService;
    protected popoverController: PopoverController;
    protected environment?: Environment;
    private defaultMaxHeight;
    private defaultMaxWidth;
    constructor(platform: PlatformService, settings: LocalSettingsService, translate: TranslateService, popoverController: PopoverController, environment?: Environment);
    protected ngOnStart(): Promise<any>;
    add(event?: Event, opts?: {
        maxHeight?: number;
        mawWidth?: number;
        quality?: number;
        multiple?: boolean;
        autoHideDropArea?: boolean;
    } & Omit<ImageOptions, 'resultType'>): Promise<Image[] | undefined>;
    protected addUploadedImages(event?: Event, opts?: {
        maxHeight?: number;
        mawWidth?: number;
        quality?: number;
        multiple?: boolean;
        autoHideDropArea?: boolean;
    }): Promise<Image[] | undefined>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ImageService, [null, null, null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ImageService>;
}
