import { ElementRef, QueryList } from '@angular/core';
import { FocusableElement } from './focusable';
export declare function selectInputContentFromEvent(event: Event): boolean;
export declare function selectInputContent(input: HTMLInputElement | HTMLTextAreaElement | any): boolean;
export declare function selectInputRange(input: HTMLInputElement | HTMLTextAreaElement, startIndex: number, endIndex?: number, direction?: 'backward' | 'forward' | 'none'): boolean;
export declare function getCaretPosition(input: any): number;
export declare function moveInputCaretToSeparator(event: KeyboardEvent, separator: string, forward?: boolean): boolean;
export declare function filterNumberInput(event: KeyboardEvent, allowDecimals: boolean, decimalSeparator?: string): void;
export declare function focusInput<T = any>(element: ElementRef<T>): void;
export declare function setTabIndex<T = any>(element: ElementRef<T>, tabIndex: number): void;
export interface InputElement extends FocusableElement {
    tabindex?: number;
    tabIndex?: number;
    hidden?: boolean;
    disabled?: boolean;
    value: any;
}
export declare function isInputElement(object: any): object is InputElement;
export declare function asInputElement<T = any>(object: ElementRef<T>): InputElement | undefined;
export declare function tabindexComparator(a: InputElement, b: InputElement): 1 | -1 | 0;
export interface CanGainFocusOptions {
    minTabindex?: number;
    maxTabindex?: number;
    isEmpty?: boolean;
    isNotEmpty?: boolean;
}
export interface GetFocusableInputOptions extends CanGainFocusOptions {
    sortByTabIndex?: boolean;
    debug?: boolean;
}
export declare function canHaveFocus(input: InputElement, opts?: CanGainFocusOptions): boolean;
export declare function getFocusableInputElements(elements: QueryList<ElementRef>, opts?: GetFocusableInputOptions): InputElement[];
export declare function focusNextInput<T = any>(event: Event | undefined, elements: QueryList<ElementRef<T>>, opts?: GetFocusableInputOptions): boolean;
export declare function focusPreviousInput<T = any>(event: Event | undefined, elements: QueryList<ElementRef<T>>, opts?: GetFocusableInputOptions): boolean;
export declare function getInputSelectionRangesFromMask(mask: (string | RegExp)[]): number[][];
export declare function getInputRangeFromCaretIndex(caretIndex: number, inputRanges: number[][]): number[];
