/**
 * Logging levels.
 * Based on https://github.com/Ritzlgrmft/ionic-logging-service/blob/main/projects/ionic-logging-service/src/lib/log-level.model.ts
 */
export declare enum LogLevel {
    /**
     * All events should be logged.
     */
    ALL = 0,
    /**
     * A fine-grained debug message, typically capturing the flow through the application.
     */
    TRACE = 1,
    /**
     * A general debugging event.
     */
    DEBUG = 2,
    /**
     * An event for informational purposes.
     */
    INFO = 3,
    /**
     * An event that might possible lead to an error.
     */
    WARN = 4,
    /**
     * An error in the application, possibly recoverable.
     */
    ERROR = 5,
    /**
     * A severe error that will prevent the application from continuing.
     */
    FATAL = 6,
    /**
     * No events will be logged.
     */
    OFF = 7
}
