import { ILogger, ILoggingAppender, ILoggingService, Log } from './logger.model';
import { InjectionToken } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { IStorage } from '../storage/storage.utils';
import { Environment } from '../../../environments/environment.class';
import { LoggingServiceConfig } from './logging-service.config';
import { LogLevel } from './log-level.model';
import { StartableService } from '../services/startable-service.class';
import * as i0 from "@angular/core";
export declare class Logger implements ILogger {
    private _name;
    private _appender;
    constructor(_name: string, _appender: ILoggingAppender);
    trace(methodName: string, ...params: any[]): void;
    debug(methodName: string, ...params: any[]): void;
    info(methodName: string, ...params: any[]): void;
    warn(methodName: string, ...params: any[]): void;
    error(methodName: string, ...params: any[]): void;
    fatal(methodName: string, ...params: any[]): void;
    private toString;
}
export declare const APP_LOGGING_SERVICE: InjectionToken<ILoggingService>;
export declare class LoggingService extends StartableService<void> implements ILoggingService, ILoggingAppender {
    private storage;
    protected environment: Environment;
    _dataSubject: BehaviorSubject<Log[]>;
    _debounceTimeMs: number;
    _storageKey: string;
    _maxMessages: number;
    _saving: boolean;
    constructor(storage: IStorage, environment: Environment);
    configure(config: LoggingServiceConfig): Promise<void>;
    protected ngOnStart(opts?: LoggingServiceConfig): Promise<void>;
    getLogger(loggerName: string): ILogger;
    append(loggerName: string, level: LogLevel, message: string): void;
    protected storeLocally(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<LoggingService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<LoggingService>;
}
