import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy } from '@angular/core';
import { LocalSettingsService } from '../../core/services/local-settings.service';
import { TranslateService } from '@ngx-translate/core';
import { NetworkService } from '../../core/services/network.service';
import { MarkdownService } from './markdown.service';
import { NavController, ToastController } from '@ionic/angular';
import { ActivatedRoute } from '@angular/router';
import { PrintService } from '../print/print.service';
import * as i0 from "@angular/core";
export interface AppMarkdownOptions {
    data?: string;
    src?: string;
    showError?: boolean;
}
export declare class AppMarkdownContent implements AppMarkdownOptions, OnDestroy {
    protected cd: ChangeDetectorRef;
    protected element: ElementRef<HTMLElement>;
    private _document;
    protected route: ActivatedRoute;
    private _printId;
    private _clickSubscription;
    protected navController: NavController;
    protected settings: LocalSettingsService;
    protected translate: TranslateService;
    protected network: NetworkService;
    protected markdownService: MarkdownService;
    protected toastController: ToastController;
    protected printService: PrintService;
    protected loading: boolean;
    protected error: string;
    protected baseUrl: string;
    protected _data: string;
    protected _src: string;
    protected _fallbackSrc: string;
    protected _anchor: string;
    protected _navHistory: {
        src?: string;
        fallbackSrc?: string;
        data?: string;
        anchor?: string;
    }[];
    set data(value: string);
    get data(): string;
    set src(value: string);
    get src(): string;
    set anchor(value: string);
    get anchor(): string;
    debug: boolean;
    showError: boolean;
    animated: boolean;
    enableNavigationHistory: boolean;
    updateRouteLocation: boolean;
    markdownUrlChange: EventEmitter<string>;
    constructor(cd: ChangeDetectorRef, element: ElementRef<HTMLElement>, _document: Document, route: ActivatedRoute);
    ngOnDestroy(): void;
    goBack(event?: Event): void;
    get canGoBack(): boolean;
    print(): Promise<void>;
    markAsLoaded(opts?: {
        emitEvent?: boolean;
    }): void;
    markAsLoading(opts?: {
        emitEvent?: boolean;
    }): void;
    setError(error: string | Error): void;
    resetError(): void;
    protected setData(value: string, opts?: {
        anchor?: string;
        addToNavigationHistory?: boolean;
    }): void;
    protected setSrc(src: string, opts?: {
        fallbackSrc?: string;
        anchor?: string;
        addToNavigationHistory?: boolean;
    }): void;
    protected onReady(): void;
    protected onLoadError(error?: string | Error): void;
    protected startListenClickEvents(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppMarkdownContent, [null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppMarkdownContent, "app-markdown-content", never, { "data": { "alias": "data"; "required": false; }; "src": { "alias": "src"; "required": false; }; "anchor": { "alias": "anchor"; "required": false; }; "debug": { "alias": "debug"; "required": false; }; "showError": { "alias": "showError"; "required": false; }; "animated": { "alias": "animated"; "required": false; }; "enableNavigationHistory": { "alias": "enableNavigationHistory"; "required": false; }; "updateRouteLocation": { "alias": "updateRouteLocation"; "required": false; }; }, { "markdownUrlChange": "markdownUrlChange"; }, never, never, false, never>;
    static ngAcceptInputType_debug: unknown;
    static ngAcceptInputType_showError: unknown;
    static ngAcceptInputType_animated: unknown;
    static ngAcceptInputType_enableNavigationHistory: unknown;
    static ngAcceptInputType_updateRouteLocation: unknown;
}
