import { ChangeDetectorRef, Injector } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { PlatformService } from '../../core/services/platform.service';
import { LocalSettingsService } from '../../core/services/local-settings.service';
import { TranslateService } from '@ngx-translate/core';
import { NetworkService } from '../../core/services/network.service';
import { AppMarkdownContent } from './markdown.component';
import * as i0 from "@angular/core";
export interface AppMarkdownModalOptions {
    title?: string;
    data?: string;
    src?: string;
    showError?: boolean;
    cssClass?: string;
    canPrint?: boolean;
    enableNavigationHistory?: boolean;
    debug?: boolean;
}
export declare class AppMarkdownModal implements AppMarkdownModalOptions {
    protected injector: Injector;
    protected viewCtrl: ModalController;
    protected platform: PlatformService;
    protected settings: LocalSettingsService;
    protected translate: TranslateService;
    protected network: NetworkService;
    protected cd: ChangeDetectorRef;
    title: string;
    showError: boolean;
    canPrint: boolean;
    data: string;
    src: string;
    enableNavigationHistory: boolean;
    debug: boolean;
    content: AppMarkdownContent;
    static show(modalCtrl: ModalController, options: AppMarkdownModalOptions): Promise<import("@ionic/core").OverlayEventDetail<any>>;
    constructor(injector: Injector, viewCtrl: ModalController, platform: PlatformService, settings: LocalSettingsService, translate: TranslateService, network: NetworkService, cd: ChangeDetectorRef);
    close(_?: Event): Promise<boolean>;
    goBack(event: Event, content: AppMarkdownContent): void;
    protected markAsLoaded(): void;
    protected markAsLoading(): void;
    protected setError(err: string | Error): void;
    protected resetError(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AppMarkdownModal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AppMarkdownModal, "app-markdown-modal", never, { "title": { "alias": "title"; "required": false; }; "showError": { "alias": "showError"; "required": false; }; "canPrint": { "alias": "canPrint"; "required": false; }; "data": { "alias": "data"; "required": false; }; "src": { "alias": "src"; "required": false; }; "enableNavigationHistory": { "alias": "enableNavigationHistory"; "required": false; }; "debug": { "alias": "debug"; "required": false; }; }, {}, never, never, false, never>;
    static ngAcceptInputType_showError: unknown;
    static ngAcceptInputType_canPrint: unknown;
    static ngAcceptInputType_enableNavigationHistory: unknown;
    static ngAcceptInputType_debug: unknown;
}
