import { UrlTree } from '@angular/router';
import { MarkedRenderer } from 'ngx-markdown';
import { Subject, Subscription } from 'rxjs';
import * as i0 from "@angular/core";
export declare class MarkdownService {
    private route;
    private router;
    private platform;
    private locationStrategy;
    private navController;
    private baseUrl;
    private readonly _defaultRenderer;
    private _markedRenderer;
    get renderer(): MarkedRenderer;
    set renderer(value: MarkedRenderer);
    onClickMarkdownUrl: Subject<string>;
    constructor();
    setBaseUrl(baseUrl: string): void;
    resetBaseUrl(): void;
    getUrlTree(url: string): UrlTree;
    navigate(url: string, replaceUrl?: boolean): void;
    listenClickEvents(nativeElement: HTMLElement): Subscription;
    /**
     * Transform a relative URL to its absolute representation according to current router state.
     * @param url Relative URL path.
     * @return Absolute URL based on the current route.
     */
    normalizeUrl(url: string): string;
    scrollToAnchor(containerElement: HTMLElement, anchorId: string): void;
    protected setRenderer(renderer: MarkedRenderer): void;
    protected click(event: Event, containerElement: HTMLElement): Promise<boolean>;
    protected link(href: string | null, title: string | null, text: string): string;
    protected image(href: string, title: string | null, text: string): string;
    protected heading(text: string, level: number, raw: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MarkdownService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MarkdownService>;
}
