import { AfterViewInit, ChangeDetectorRef, OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { MatAutocompleteField } from '../material.autocomplete';
import { BehaviorSubject, Subscription } from 'rxjs';
import { LoadResult } from '../../../services/entity-service.class';
import { MatAutocompleteConfigHolder } from '../material.autocomplete.config';
import { IonModal } from '@ionic/angular';
import * as i0 from "@angular/core";
declare class EntityTestClass {
    id: number;
    label: string;
    name: string;
}
export declare class AutocompleteTestPage implements OnInit, AfterViewInit {
    protected formBuilder: UntypedFormBuilder;
    private cd;
    protected _items: any[];
    protected _$items: BehaviorSubject<EntityTestClass[]>;
    protected _favoriteItems: any[];
    protected _favoriteFarItems: any[];
    form: UntypedFormGroup;
    autocompleteFields: MatAutocompleteConfigHolder;
    memoryHide: boolean;
    memoryMobile: boolean;
    memoryAutocompleteFieldName: string;
    memoryTimer: Subscription;
    mode: 'mobile' | 'desktop' | 'memory' | 'temp';
    farEntityField: MatAutocompleteField;
    ionModal: IonModal;
    constructor(formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadData(): Promise<void>;
    loadItems(): Promise<void>;
    entityToString(item: any): string;
    entitiesToString(items: any[]): string;
    suggest(value: any, filter?: any): Promise<LoadResult<EntityTestClass>>;
    doSubmit(_: any): void;
    equals(o1: EntityTestClass, o2: EntityTestClass): boolean;
    toggleMode(value: any): void;
    startMemoryTimer(): void;
    stopMemoryTimer(): void;
    updateFilter(autocompleteField: MatAutocompleteField, fieldName: string): void;
    stringify(value: any): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<AutocompleteTestPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AutocompleteTestPage, "app-autocomplete-test", never, {}, {}, never, never, false, never>;
}
export {};
