import { AfterViewInit, ElementRef, NgZone, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { MatBadge, MatBadgePosition, MatBadgeSize } from '@angular/material/badge';
import { AppColors } from '../../types';
import { AriaDescriber } from '@angular/cdk/a11y';
import { BooleanInput } from '@angular/cdk/coercion';
import * as i0 from "@angular/core";
export declare type MatBadgeFill = 'clear' | 'solid';
export declare class BadgeDirective extends MatBadge implements AfterViewInit, OnChanges, OnDestroy, OnInit {
    protected el: ElementRef<HTMLElement>;
    true: any;
    get isOverlapHost(): boolean;
    get isAboveHost(): boolean;
    get isBelowHost(): boolean;
    get isBeforeHost(): boolean;
    get isAfterHost(): boolean;
    get isSmallHost(): boolean;
    get isMediumHost(): boolean;
    get isLargeHost(): boolean;
    get isHiddenHost(): boolean;
    get isDisabledHost(): boolean;
    set appBadge(value: string | number);
    get appBadge(): string | number;
    set appBadgeDisabled(value: boolean);
    get appBadgeDisabled(): boolean;
    set appBadgeSize(value: MatBadgeSize);
    get appBadgeSize(): MatBadgeSize;
    appBadgeColor: AppColors;
    appBadgeFill: MatBadgeFill;
    appBadgeMatIcon: string;
    appBadgeIcon: string;
    appBadgeHidden: BooleanInput;
    appBadgeOverlap: BooleanInput;
    appBadgePosition: MatBadgePosition;
    private _html;
    constructor(_ngZone: NgZone, el: ElementRef<HTMLElement>, _ariaDescriber: AriaDescriber, _renderer: Renderer2, _animationMode?: string | undefined);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private updateView;
    static ɵfac: i0.ɵɵFactoryDeclaration<BadgeDirective, [null, null, null, null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BadgeDirective, "[appBadge], [appBadgeIcon], [appBadgeMatIcon]", never, { "appBadge": { "alias": "appBadge"; "required": false; }; "appBadgeDisabled": { "alias": "appBadgeDisabled"; "required": false; }; "appBadgeSize": { "alias": "appBadgeSize"; "required": false; }; "appBadgeColor": { "alias": "appBadgeColor"; "required": false; }; "appBadgeFill": { "alias": "appBadgeFill"; "required": false; }; "appBadgeMatIcon": { "alias": "appBadgeMatIcon"; "required": false; }; "appBadgeIcon": { "alias": "appBadgeIcon"; "required": false; }; "appBadgeHidden": { "alias": "appBadgeHidden"; "required": false; }; "appBadgeOverlap": { "alias": "appBadgeOverlap"; "required": false; }; "appBadgePosition": { "alias": "appBadgePosition"; "required": false; }; }, {}, never, never, false, never>;
}
