import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { MatFormFieldAppearance, SubscriptSizing } from '@angular/material/form-field';
import { ControlValueAccessor, FormGroupDirective, UntypedFormControl } from '@angular/forms';
import { MatRadioButton, MatRadioChange } from '@angular/material/radio';
import { MatCheckbox, MatCheckboxChange } from '@angular/material/checkbox';
import { InputElement } from '../../inputs';
import { AppFloatLabelType } from '../../form/field.model';
import * as i0 from "@angular/core";
export declare class MatBooleanField implements OnInit, ControlValueAccessor, InputElement, OnDestroy {
    private cd;
    private formGroupDir;
    private _onChangeCallback;
    private _onTouchedCallback;
    private readonly _subscription;
    private _writing;
    protected _value: boolean;
    protected _tabindex: number;
    protected _showRadio: boolean;
    protected _focused: boolean;
    fakeInput: ElementRef;
    yesRadioButton: MatRadioButton;
    noRadioButton: MatRadioButton;
    checkboxButton: MatCheckbox;
    disabled: boolean;
    formControl: UntypedFormControl;
    formControlName: string;
    placeholder: string;
    floatLabel: AppFloatLabelType;
    appearance: MatFormFieldAppearance;
    subscriptSizing: SubscriptSizing;
    readonly: boolean;
    required: boolean;
    compact: boolean;
    autofocus: boolean;
    style: 'radio' | 'checkbox' | 'button';
    buttonsColCount: number;
    classList: string;
    yesLabel: string;
    noLabel: string;
    showButtonIcons: boolean;
    yesIcon: string;
    noIcon: string;
    clearable: boolean;
    labelPosition: 'after' | 'before';
    set tabindex(value: number);
    get tabindex(): number;
    set showRadio(v: any);
    get showRadio(): any;
    set value(v: any);
    get value(): any;
    keyupEnter: EventEmitter<any>;
    focussed: EventEmitter<FocusEvent>;
    blurred: EventEmitter<FocusEvent>;
    constructor(cd: ChangeDetectorRef, formGroupDir: FormGroupDirective);
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: any, event?: Event): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    protected onFocusFakeInput(event: FocusEvent): void;
    protected onBlurInput(event: FocusEvent): void;
    focus(): void;
    protected onRadioValueChanged(event: MatRadioChange): void;
    protected onCheckboxValueChanged(event: MatCheckboxChange): void;
    toggleValue(event?: Event): void;
    private emitChange;
    private _checkIfTouched;
    /**
     * Show/Hide the fake input
     */
    private updateFakeInput;
    /**
     * This is a special case, because, this component has a temporary component displayed before the first focus event
     */
    private updateTabIndex;
    private markForCheck;
    clearValue(event?: Event): void;
    protected get radioButtonElements(): HTMLElement[];
    protected get inputsElements(): HTMLElement[];
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBooleanField, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBooleanField, "mat-boolean-field", never, { "disabled": { "alias": "disabled"; "required": false; }; "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "required": { "alias": "required"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "style": { "alias": "style"; "required": false; }; "buttonsColCount": { "alias": "buttonsColCount"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "yesLabel": { "alias": "yesLabel"; "required": false; }; "noLabel": { "alias": "noLabel"; "required": false; }; "showButtonIcons": { "alias": "showButtonIcons"; "required": false; }; "yesIcon": { "alias": "yesIcon"; "required": false; }; "noIcon": { "alias": "noIcon"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "labelPosition": { "alias": "labelPosition"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "showRadio": { "alias": "showRadio"; "required": false; }; "value": { "alias": "value"; "required": false; }; }, { "keyupEnter": "keyup.enter"; "focussed": "focus"; "blurred": "blur"; }, never, ["[matPrefix]", "[matSuffix]"], false, never>;
    static ngAcceptInputType_disabled: unknown;
    static ngAcceptInputType_readonly: unknown;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_compact: unknown;
    static ngAcceptInputType_autofocus: unknown;
    static ngAcceptInputType_buttonsColCount: unknown;
    static ngAcceptInputType_showButtonIcons: unknown;
    static ngAcceptInputType_clearable: unknown;
    static ngAcceptInputType_tabindex: unknown;
    static ngAcceptInputType_showRadio: unknown;
}
