import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, UntypedFormBuilder, UntypedFormControl } from '@angular/forms';
import { TranslateService } from '@ngx-translate/core';
import { Moment } from 'moment';
import { InputElement } from '../../inputs';
import { MatFormFieldAppearance, MatFormFieldDefaultOptions, SubscriptSizing } from '@angular/material/form-field';
import { DateFilterFn, MatDatepicker, MatDatepickerInputEvent } from '@angular/material/datepicker';
import { MomentDateAdapter } from '@angular/material-moment-adapter';
import { AppFloatLabelType } from '../../form/field.model';
import { MaskitoOptions } from '@maskito/core';
import * as i0 from "@angular/core";
export declare class MatDate implements OnInit, AfterViewInit, OnDestroy, ControlValueAccessor, InputElement {
    private dateAdapter;
    private translate;
    private formBuilder;
    private cd;
    private formGroupDir;
    private _onChangeCallback;
    private _onTouchedCallback;
    private readonly _subscription;
    private _writing;
    private _disabling;
    private _tabindex;
    private _readonly;
    private _appearance;
    private _subscriptSizing;
    private readonly _defaultAppearance;
    private readonly _defaultSubscriptSizing;
    protected textControl: UntypedFormControl;
    protected datePattern: string;
    protected locale: string;
    protected maskitoOptions: MaskitoOptions;
    protected datePlaceholder: string;
    formControl: UntypedFormControl;
    formControlName: string;
    placeholder: string;
    floatLabel: AppFloatLabelType;
    mobile: boolean;
    compact: boolean;
    autofocus: boolean;
    clearable: boolean;
    required: boolean;
    startDate: Moment | null;
    timezone: string;
    datePickerFilter: DateFilterFn<Moment>;
    set appearance(value: MatFormFieldAppearance);
    get appearance(): MatFormFieldAppearance;
    set subscriptSizing(value: SubscriptSizing);
    get subscriptSizing(): SubscriptSizing;
    set readonly(value: boolean);
    get readonly(): boolean;
    set tabindex(value: number);
    get tabindex(): number;
    get value(): any;
    get disabled(): boolean;
    datePicker: MatDatepicker<Moment>;
    _matInput: ElementRef;
    constructor(dateAdapter: MomentDateAdapter, translate: TranslateService, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef, formGroupDir: FormGroupDirective, defaultOptions?: MatFormFieldDefaultOptions);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    openDatePicker(): void;
    focus(): void;
    clear(event: Event): void;
    protected _onDatePickerChange(event: MatDatepickerInputEvent<Moment>): void;
    protected _openDatePickerIfMobile(event: Event): void;
    protected _onBlur(): void;
    protected _checkIfTouched(): void;
    protected _preventEvent(event?: Event): void;
    private updateTranslations;
    private updatePattern;
    private updateMaskOptions;
    private onFormChange;
    private emitChange;
    private updateTabIndex;
    private markAsTouched;
    private markAsDirty;
    private markForCheck;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatDate, [null, null, null, null, { optional: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatDate, "mat-date-field", never, { "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "mobile": { "alias": "mobile"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "required": { "alias": "required"; "required": false; }; "startDate": { "alias": "startDate"; "required": false; }; "timezone": { "alias": "timezone"; "required": false; }; "datePickerFilter": { "alias": "datePickerFilter"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; }, {}, never, ["[matPrefix]", "[matSuffix]", "mat-error,[matError]", "mat-hint:not([align='end']),[matHint]", "mat-hint[align='end']"], false, never>;
    static ngAcceptInputType_mobile: unknown;
    static ngAcceptInputType_compact: unknown;
    static ngAcceptInputType_autofocus: unknown;
    static ngAcceptInputType_clearable: unknown;
    static ngAcceptInputType_required: unknown;
}
