import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, OnInit, QueryList } from '@angular/core';
import { MatFormFieldAppearance, MatFormFieldDefaultOptions, SubscriptSizing } from '@angular/material/form-field';
import { ControlValueAccessor, FormGroupDirective, UntypedFormBuilder, UntypedFormControl } from '@angular/forms';
import { TranslateService } from '@ngx-translate/core';
import { Moment } from 'moment';
import { InputElement } from '../../inputs';
import { DateFilterFn, MatDatepicker, MatDatepickerInputEvent } from '@angular/material/datepicker';
import { MomentDateAdapter } from '@angular/material-moment-adapter';
import { AppFloatLabelType } from '../../form/field.model';
import { MaskitoOptions } from '@maskito/core';
import * as i0 from "@angular/core";
declare interface NgxTimePicker {
    open(): any;
    close(): any;
}
export declare class MatDateTime implements OnInit, AfterViewInit, OnDestroy, ControlValueAccessor, InputElement {
    private dateAdapter;
    private translate;
    private formBuilder;
    private cd;
    private formGroupDir;
    private _onChangeCallback;
    private _onTouchedCallback;
    private _subscription;
    private _controlSubscription;
    private _writing;
    private _disabling;
    private _tabindex;
    private _readonly;
    private _controlName;
    private _required;
    private _appearance;
    private _subscriptSizing;
    private readonly _defaultAppearance;
    private readonly _defaultSubscriptSizing;
    protected _formControl: UntypedFormControl;
    protected dateControl: UntypedFormControl;
    protected timeControl: UntypedFormControl;
    protected displayPattern: string;
    protected datePattern: string;
    protected timePattern: string;
    protected locale: string;
    protected maskitoDateOptions: MaskitoOptions;
    protected maskitoTimeOptions: MaskitoOptions;
    protected datePlaceholder: string;
    protected timePlaceholder: string;
    placeholder: string;
    floatLabel: AppFloatLabelType;
    mobile: boolean;
    compact: boolean;
    autofocus: boolean;
    clearable: boolean;
    startDate: Moment | null;
    datePickerFilter: DateFilterFn<Moment>;
    allowNoTime: boolean;
    set appearance(value: MatFormFieldAppearance);
    get appearance(): MatFormFieldAppearance;
    set subscriptSizing(value: SubscriptSizing);
    get subscriptSizing(): SubscriptSizing;
    set formControl(value: UntypedFormControl);
    get formControl(): UntypedFormControl;
    set formControlName(value: string);
    get formControlName(): string;
    set required(value: boolean | any);
    get required(): boolean | any;
    get requiredTime(): boolean | any;
    set readonly(value: boolean);
    get readonly(): boolean;
    set tabindex(value: number);
    get tabindex(): number;
    get value(): any;
    get disabled(): boolean;
    datePicker: MatDatepicker<Moment>;
    timePicker: NgxTimePicker;
    _matInputs: QueryList<ElementRef>;
    constructor(dateAdapter: MomentDateAdapter, translate: TranslateService, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef, formGroupDir: FormGroupDirective, defaultOptions?: MatFormFieldDefaultOptions);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    openDatePicker(event?: Event, datePicker?: MatDatepicker<any>): void;
    openTimePicker(event?: Event): void;
    focus(): void;
    clear(event?: Event): void;
    protected _setFormControlName(controlName: string): void;
    protected _setFormControl(control: UntypedFormControl): void;
    protected _updateControlValidators(control: UntypedFormControl, required: boolean): void;
    protected _onDatePickerChange(event: MatDatepickerInputEvent<Moment>): void;
    protected _onTimePickerChange(timeStr: string): void;
    protected _openDatePickerIfMobile(event?: Event, datePicker?: MatDatepicker<any>): void;
    protected _openTimePickerIfMobile(event?: Event): void;
    protected _onBlur(): void;
    protected _checkIfTouched(): void;
    protected _preventEvent(event?: Event): void;
    private updateTranslations;
    private updateDisplayPattern;
    private updateDateMaskOptions;
    private updateTimeMaskOptions;
    private onFormChange;
    private emitChange;
    private updateTabIndex;
    private markAsTouched;
    private markAsDirty;
    private markForCheck;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatDateTime, [null, null, null, null, { optional: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatDateTime, "mat-date-time-field", never, { "placeholder": { "alias": "placeholder"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "mobile": { "alias": "mobile"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "startDate": { "alias": "startDate"; "required": false; }; "datePickerFilter": { "alias": "datePickerFilter"; "required": false; }; "allowNoTime": { "alias": "allowNoTime"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "required": { "alias": "required"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; }, {}, never, ["[matPrefix]", "[matSuffix]", "mat-error,[matError]", "mat-hint:not([align='end']),[matHint]", "mat-hint[align='end']"], false, never>;
    static ngAcceptInputType_mobile: unknown;
    static ngAcceptInputType_compact: unknown;
    static ngAcceptInputType_autofocus: unknown;
    static ngAcceptInputType_clearable: unknown;
    static ngAcceptInputType_allowNoTime: unknown;
}
export {};
