import { ChangeDetectorRef, OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { Platform } from '@ionic/angular';
import { Subscription } from 'rxjs';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { MatCheckboxChange } from '@angular/material/checkbox';
import * as i0 from "@angular/core";
export declare class DateTimeTestPage implements OnInit {
    protected platform: Platform;
    protected formBuilder: UntypedFormBuilder;
    protected cd: ChangeDetectorRef;
    showLogPanel: boolean;
    logContent: string;
    memoryHide: boolean;
    memoryMobile: boolean;
    memoryTimer: Subscription;
    form: UntypedFormGroup;
    mode: 'mobile' | 'desktop' | 'memory' | 'temp';
    appearance: MatFormFieldAppearance;
    noTimeProperty: string;
    constructor(platform: Platform, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef);
    ngOnInit(): void;
    toggleMode(value: any): void;
    toggleAppearance(event: MatCheckboxChange): void;
    loadData(): Promise<void>;
    doSubmit(event?: Event): void;
    log(message: string): void;
    clearLogPanel(): void;
    startMemoryTimer(): void;
    stopMemoryTimer(): void;
    stringify: {
        (value: any, replacer?: (this: any, key: string, value: any) => any, space?: string | number): string;
        (value: any, replacer?: (string | number)[], space?: string | number): string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<DateTimeTestPage, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DateTimeTestPage, "app-data-time-test", never, {}, {}, never, never, false, never>;
}
