import { ChangeDetectorRef, ElementRef, OnDestroy, OnInit, QueryList } from '@angular/core';
import { Platform } from '@ionic/angular';
import { DateAdapter } from '@angular/material/core';
import { ControlValueAccessor, FormGroupDirective, UntypedFormBuilder, UntypedFormControl } from '@angular/forms';
import { TranslateService } from '@ngx-translate/core';
import { Moment } from 'moment';
import { InputElement } from '../../inputs';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { AppFloatLabelType } from '../../form/field.model';
import * as i0 from "@angular/core";
export declare class MatDuration implements OnInit, OnDestroy, ControlValueAccessor, InputElement {
    private dateAdapter;
    private translate;
    private formBuilder;
    private cd;
    private formGroupDir;
    private _subscription;
    private _onChangeCallback;
    private _onTouchedCallback;
    private writing;
    private disabling;
    private _tabindex;
    private _value;
    textControl: UntypedFormControl;
    maskitoPlaceholder: string;
    readonly durationMask: (string | RegExp)[];
    disabled: boolean;
    formControl: UntypedFormControl;
    formControlName: string;
    placeholder: string;
    floatLabel: AppFloatLabelType;
    appearance: MatFormFieldAppearance;
    readonly: boolean;
    required: boolean;
    compact: boolean;
    maxDecimals: number;
    placeholderChar: string;
    set tabindex(value: number);
    get tabindex(): number;
    clearable: boolean;
    matInputs: QueryList<ElementRef>;
    get value(): any;
    protected dayUnit: string;
    constructor(platform: Platform, dateAdapter: DateAdapter<Moment>, translate: TranslateService, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef, formGroupDir: FormGroupDirective);
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    private onFormChange;
    checkIfTouched(): void;
    preventEvent(event: Event): void;
    focus(): void;
    moveCaretToSeparator(event: any, forward: boolean): boolean;
    protected updateTabIndex(): void;
    protected markForCheck(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatDuration, [null, null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatDuration, "mat-duration-field", never, { "disabled": { "alias": "disabled"; "required": false; }; "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "required": { "alias": "required"; "required": false; }; "compact": { "alias": "compact"; "required": false; }; "maxDecimals": { "alias": "maxDecimals"; "required": false; }; "placeholderChar": { "alias": "placeholderChar"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; }, {}, never, ["[matPrefix]", "mat-error", "[matPrefix]", "mat-error"], false, never>;
    static ngAcceptInputType_disabled: unknown;
    static ngAcceptInputType_readonly: unknown;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_compact: unknown;
}
