import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { LatLongPattern, LatLongSign, LatLongType } from './latlong.utils';
import { MaskitoOptions } from '@maskito/core';
import { MatFormField, MatFormFieldControl } from '@angular/material/form-field';
import { Subject } from 'rxjs';
import { BooleanInput } from '@angular/cdk/coercion';
import * as i0 from "@angular/core";
export declare class MatLatLongFieldInput implements MatFormFieldControl<number>, ControlValueAccessor, OnInit, OnDestroy {
    private _elementRef;
    _formField: MatFormField;
    ngControl: NgControl;
    static nextId: number;
    degreesInput: ElementRef;
    minutesInput: ElementRef;
    secondsInput: ElementRef;
    signInput: ElementRef;
    protected formGroup: import("@angular/forms").FormGroup<{
        degrees: import("@angular/forms").FormControl<string>;
        minutes: import("@angular/forms").FormControl<string>;
        seconds: import("@angular/forms").FormControl<string>;
        sign: import("@angular/forms").FormControl<1 | -1>;
    }>;
    stateChanges: Subject<void>;
    focused: boolean;
    touched: boolean;
    controlType: string;
    id: string;
    onChange: (_: any) => void;
    onTouched: () => void;
    get empty(): boolean;
    get shouldLabelFloat(): boolean;
    userAriaDescribedBy: string;
    placeholder: string;
    get required(): boolean;
    set required(value: BooleanInput);
    private _required;
    get disabled(): boolean;
    set disabled(value: BooleanInput);
    private _disabled;
    get value(): number | null;
    set value(value: number | null);
    get errorState(): boolean;
    type: LatLongType;
    pattern: LatLongPattern;
    defaultSign: LatLongSign;
    maxDecimals: number;
    readonly: boolean;
    protected degreesSymbolUnit: string;
    protected minutesSymbolUnit: string;
    protected secondsSymbolUnit: string;
    protected showMinutes: boolean;
    protected showSeconds: boolean;
    protected showSign: boolean;
    protected degreesMask: MaskitoOptions;
    protected minutesMask: MaskitoOptions;
    protected secondsMask: MaskitoOptions;
    protected degreesPlaceholder: string;
    protected minutesPlaceholder: string;
    protected secondsPlaceholder: string;
    protected lastInputMaxDecimals: number;
    private logPrefix;
    private _subscription;
    private cd;
    constructor(_elementRef: ElementRef<HTMLElement>, _formField: MatFormField, ngControl: NgControl);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFocusIn(event: FocusEvent): void;
    onFocusOut(event: FocusEvent): void;
    handleInput(controlName: string, nextControlName?: string): void;
    autoFocusNext(controlName: string, nextControlName?: string): void;
    autoFocusPrev(controlName: string, prevControlName: string): void;
    getElementByName(name: string): HTMLElement | undefined;
    setDescribedByIds(ids: string[]): void;
    onContainerClick(): void;
    writeValue(value: number | null): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    private computeLatLongFormGroupValue;
    private safeParseFloat;
    private updateValidators;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLatLongFieldInput, [null, { optional: true; }, { optional: true; self: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatLatLongFieldInput, "mat-latlong-input", never, { "userAriaDescribedBy": { "alias": "aria-describedby"; "required": false; }; "required": { "alias": "required"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "value": { "alias": "value"; "required": false; }; "type": { "alias": "type"; "required": false; }; "pattern": { "alias": "latLongPattern"; "required": false; }; "defaultSign": { "alias": "defaultSign"; "required": false; }; "maxDecimals": { "alias": "maxDecimals"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; }, {}, never, never, false, never>;
}
