import { AfterViewInit, ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, UntypedFormControl } from '@angular/forms';
import { MatFormFieldAppearance, MatFormFieldDefaultOptions, SubscriptSizing } from '@angular/material/form-field';
import { AppFloatLabelType } from '../../form/field.model';
import { LatLongPattern, LatLongSign, LatLongType } from './latlong.utils';
import { MatLatLongFieldInput } from './material.latlong-input';
import * as i0 from "@angular/core";
export declare class MatLatLongField implements ControlValueAccessor, OnInit, AfterViewInit, OnDestroy {
    private cd;
    private formGroupDir;
    private _subscription;
    private _appearance;
    private _subscriptSizing;
    private _readonly;
    private _tabindex;
    private readonly _defaultAppearance;
    private readonly _defaultSubscriptSizing;
    protected i18nErrorKeys: {
        required: string;
        min: string;
        max: string;
        minlength: string;
        maxlength: string;
        pubkey: string;
        validDate: string;
        dateIsAfter: string;
        dateIsBefore: string;
        dateRange: string;
        dateMinDuration: string;
        dateMaxDuration: string;
        maxDecimals: string;
        decimal: string;
        integer: string;
        precision: string;
        email: string;
        latitude: string;
        longitude: string;
        pattern: string;
        unique: string;
        entity: string;
        invalid: string;
        inconsistent: string;
        equals: string;
    };
    formControl: UntypedFormControl;
    formControlName: string;
    type: LatLongType;
    pattern: LatLongPattern;
    maxDecimals: number;
    required: boolean;
    floatLabel: AppFloatLabelType;
    placeholder: string;
    defaultSign: LatLongSign;
    autofocus: boolean;
    mobile: boolean;
    clearable: boolean;
    classList: string;
    set tabindex(value: number);
    get tabindex(): number;
    set appearance(value: MatFormFieldAppearance);
    get appearance(): MatFormFieldAppearance;
    set readonly(value: boolean);
    get readonly(): boolean;
    set subscriptSizing(value: SubscriptSizing);
    get subscriptSizing(): SubscriptSizing;
    get disabled(): any;
    input: MatLatLongFieldInput;
    pendingValue: any;
    pendingValueSet: boolean;
    pendingDisabledState: boolean;
    pendingOnChange: (_: any) => unknown;
    pendingOnTouched: () => unknown;
    constructor(cd: ChangeDetectorRef, formGroupDir: FormGroupDirective, defaultOptions?: MatFormFieldDefaultOptions);
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    clearValue(event?: Event): void;
    private markForCheck;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLatLongField, [null, { optional: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatLatLongField, "mat-latlong-field", never, { "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "type": { "alias": "type"; "required": false; }; "pattern": { "alias": "latLongPattern"; "required": false; }; "maxDecimals": { "alias": "maxDecimals"; "required": false; }; "required": { "alias": "required"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "defaultSign": { "alias": "defaultSign"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "mobile": { "alias": "mobile"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; }, {}, never, ["[matPrefix]", "[matSuffix]", "mat-error,[matError]", "mat-hint:not([align='end']),[matHint]", "mat-hint[align='end']"], false, never>;
    static ngAcceptInputType_required: unknown;
    static ngAcceptInputType_autofocus: unknown;
    static ngAcceptInputType_mobile: unknown;
    static ngAcceptInputType_clearable: unknown;
    static ngAcceptInputType_tabindex: unknown;
}
