import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, UntypedFormControl } from '@angular/forms';
import { BehaviorSubject, Observable } from 'rxjs';
import { InputElement } from '../../inputs';
import { AppFloatLabelType, DisplayFn, EqualsFn } from '../../form/field.model';
import { Swiper } from 'swiper/types';
import { MatFormFieldAppearance, SubscriptSizing } from '@angular/material/form-field';
import { MatButton } from '@angular/material/button';
import * as i0 from "@angular/core";
export declare class MatSwipeField implements OnInit, InputElement, OnDestroy, ControlValueAccessor {
    protected cd: ChangeDetectorRef;
    private formGroupDir;
    private _onChangeCallback;
    private _onTouchedCallback;
    private _value;
    private _subscription;
    private _itemsSubscription;
    private _writing;
    private _tabindex;
    private _swiper;
    protected previousDisabled: boolean;
    protected nextDisabled: boolean;
    protected showSlides: boolean;
    protected $items: BehaviorSubject<any[]>;
    protected $loaded: BehaviorSubject<boolean>;
    logPrefix: string;
    formControl: UntypedFormControl;
    formControlName: string;
    floatLabel: AppFloatLabelType;
    appearance: MatFormFieldAppearance;
    subscriptSizing: SubscriptSizing;
    placeholder: string;
    debug: boolean;
    required: boolean;
    mobile: boolean;
    clearable: boolean;
    equals: EqualsFn | null;
    displayWith: DisplayFn | null;
    displayAttributes: string[];
    appAutofocus: boolean;
    classList: string;
    set tabindex(value: number);
    get tabindex(): number;
    set items(value: Observable<any[]> | any[]);
    get items(): Observable<any[]> | any[];
    get itemCount(): number;
    onClick: EventEmitter<MouseEvent>;
    blurred: EventEmitter<FocusEvent>;
    focused: EventEmitter<FocusEvent>;
    fakeInput: ElementRef;
    swiperRef: ElementRef | undefined;
    prevButton: MatButton;
    nextButton: MatButton;
    get value(): any;
    get disabled(): any;
    get enabled(): any;
    protected getSwiper(): Swiper;
    constructor(cd: ChangeDetectorRef, formGroupDir: FormGroupDirective);
    ngOnInit(): void;
    ngOnDestroy(): void;
    _onFocusFakeInput(event: FocusEvent): void;
    focus(): void;
    /**
     * This is a special case, because, this component has a temporary component displayed before the first focus event
     */
    private updateTabIndex;
    writeValue(value: any): void;
    clearValue(event: Event): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    previous(): void;
    next(): void;
    reachStart(reached: boolean): void;
    reachEnd(reached: boolean): void;
    swiperLoaded(): void;
    slideChanged(): void;
    private lockSwipes;
    private loadItems;
    private checkIfTouched;
    private markForCheck;
    private updateSlides;
    private slideTo;
    private updateButtons;
    ready(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatSwipeField, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatSwipeField, "mat-swipe-field", never, { "logPrefix": { "alias": "logPrefix"; "required": false; }; "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "debug": { "alias": "debug"; "required": false; }; "required": { "alias": "required"; "required": false; }; "mobile": { "alias": "mobile"; "required": false; }; "clearable": { "alias": "clearable"; "required": false; }; "equals": { "alias": "equals"; "required": false; }; "displayWith": { "alias": "displayWith"; "required": false; }; "displayAttributes": { "alias": "displayAttributes"; "required": false; }; "appAutofocus": { "alias": "appAutofocus"; "required": false; }; "classList": { "alias": "class"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "items": { "alias": "items"; "required": false; }; }, { "onClick": "click"; "blurred": "blur"; "focused": "focus"; }, never, never, false, never>;
    static ngAcceptInputType_required: unknown;
}
