import { OnDestroy } from '@angular/core';
import { AbstractControl, ControlValueAccessor, FormControl, FormGroup, NgControl } from '@angular/forms';
import { MatFormFieldControl } from '@angular/material/form-field';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/** @title Form field with custom telephone number input control. */
export declare class FormFieldCustomControlExample {
    readonly form: FormGroup<{
        tel: FormControl<any>;
    }>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormFieldCustomControlExample, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormFieldCustomControlExample, "form-field-custom-control-example", never, {}, {}, never, never, true, never>;
}
/** Data structure for holding telephone number. */
export declare class MyTel {
    area: string;
    exchange: string;
    subscriber: string;
    constructor(area: string, exchange: string, subscriber: string);
}
/** Custom `MatFormFieldControl` for telephone number input. */
export declare class MyTelInput implements ControlValueAccessor, MatFormFieldControl<MyTel>, OnDestroy {
    static nextId: number;
    readonly areaInput: import("@angular/core").Signal<HTMLInputElement>;
    readonly exchangeInput: import("@angular/core").Signal<HTMLInputElement>;
    readonly subscriberInput: import("@angular/core").Signal<HTMLInputElement>;
    ngControl: NgControl;
    readonly parts: FormGroup<{
        area: FormControl<string | null>;
        exchange: FormControl<string | null>;
        subscriber: FormControl<string | null>;
    }>;
    readonly stateChanges: Subject<void>;
    readonly touched: import("@angular/core").WritableSignal<boolean>;
    readonly controlType = "example-tel-input";
    readonly id: string;
    readonly _userAriaDescribedBy: import("@angular/core").InputSignal<string>;
    readonly _placeholder: import("@angular/core").InputSignal<string>;
    readonly _required: import("@angular/core").InputSignalWithTransform<boolean, unknown>;
    readonly _disabledByInput: import("@angular/core").InputSignalWithTransform<boolean, unknown>;
    readonly _value: import("@angular/core").ModelSignal<MyTel>;
    onChange: (_: any) => void;
    onTouched: () => void;
    protected readonly _formField: import("@angular/material/form-field").MatFormField;
    private readonly _focused;
    private readonly _disabledByCva;
    private readonly _disabled;
    private readonly _focusMonitor;
    private readonly _elementRef;
    get focused(): boolean;
    get empty(): boolean;
    get shouldLabelFloat(): boolean;
    get userAriaDescribedBy(): string;
    get placeholder(): string;
    get required(): boolean;
    get disabled(): boolean;
    get value(): MyTel | null;
    get errorState(): boolean;
    constructor();
    ngOnDestroy(): void;
    onFocusIn(): void;
    onFocusOut(event: FocusEvent): void;
    autoFocusNext(control: AbstractControl, nextElement?: HTMLInputElement): void;
    autoFocusPrev(control: AbstractControl, prevElement: HTMLInputElement): void;
    setDescribedByIds(ids: string[]): void;
    onContainerClick(): void;
    writeValue(tel: MyTel | null): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    _handleInput(control: AbstractControl, nextElement?: HTMLInputElement): void;
    private _updateValue;
    static ɵfac: i0.ɵɵFactoryDeclaration<MyTelInput, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MyTelInput, "example-tel-input", never, { "_userAriaDescribedBy": { "alias": "aria-describedby"; "required": false; "isSignal": true; }; "_placeholder": { "alias": "placeholder"; "required": false; "isSignal": true; }; "_required": { "alias": "required"; "required": false; "isSignal": true; }; "_disabledByInput": { "alias": "disabled"; "required": false; "isSignal": true; }; "_value": { "alias": "value"; "required": false; "isSignal": true; }; }, { "_value": "valueChange"; }, never, never, true, never>;
}
