import { ChangeDetectorRef, ElementRef, EventEmitter, Injector, OnInit } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, UntypedFormBuilder, UntypedFormControl, ValidatorFn } from '@angular/forms';
import { CdkTextareaAutosize } from '@angular/cdk/text-field';
import { AppForm } from '../../../core/form/form.class';
import { AppFloatLabelType } from '../../form/field.model';
import { MatFormFieldAppearance, SubscriptSizing } from '@angular/material/form-field';
import * as i0 from "@angular/core";
export declare class TextForm extends AppForm<{
    text: string;
}> implements OnInit, ControlValueAccessor {
    protected injector: Injector;
    protected cd: ChangeDetectorRef;
    protected formBuilder: UntypedFormBuilder;
    private formGroupDir;
    showError: boolean;
    placeholder: string;
    multiline: boolean;
    autoSize: boolean;
    autoSizeMinRows: number;
    autoSizeMaxRows: number;
    maxLength: number;
    autofocus: boolean;
    validator: ValidatorFn;
    standalone: boolean;
    formControl: UntypedFormControl;
    formControlName: string;
    floatLabel: AppFloatLabelType;
    appearance: MatFormFieldAppearance;
    subscriptSizing: SubscriptSizing;
    /**
     * @deprecated Use autoSize instead
     */
    set autoHeight(value: boolean);
    get autoHeight(): boolean;
    textAreaChanges: EventEmitter<string>;
    textArea: ElementRef;
    textInput: ElementRef;
    autosizeDirective: CdkTextareaAutosize;
    textControl: UntypedFormControl;
    private _onChangeCallback;
    private _onTouchedCallback;
    constructor(injector: Injector, cd: ChangeDetectorRef, formBuilder: UntypedFormBuilder, formGroupDir: FormGroupDirective);
    ngOnInit(): void;
    containerResize(): void;
    focusInput(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(value: any): void;
    protected markForCheck(): void;
    protected checkIfTouched(opts?: {
        emitEvent?: boolean;
    }): void;
    private textFormValueChanged;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextForm, [null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextForm, "app-text-form", never, { "showError": { "alias": "showError"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "multiline": { "alias": "multiline"; "required": false; }; "autoSize": { "alias": "autoSize"; "required": false; }; "autoSizeMinRows": { "alias": "autoSizeMinRows"; "required": false; }; "autoSizeMaxRows": { "alias": "autoSizeMaxRows"; "required": false; }; "maxLength": { "alias": "maxLength"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "validator": { "alias": "validator"; "required": false; }; "standalone": { "alias": "standalone"; "required": false; }; "formControl": { "alias": "formControl"; "required": false; }; "formControlName": { "alias": "formControlName"; "required": false; }; "floatLabel": { "alias": "floatLabel"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "autoHeight": { "alias": "autoHeight"; "required": false; }; }, { "textAreaChanges": "textAreaChanges"; }, never, ["[matError]"], false, never>;
    static ngAcceptInputType_showError: unknown;
    static ngAcceptInputType_multiline: unknown;
    static ngAcceptInputType_autoSize: unknown;
    static ngAcceptInputType_autoSizeMinRows: unknown;
    static ngAcceptInputType_autoSizeMaxRows: unknown;
    static ngAcceptInputType_maxLength: unknown;
    static ngAcceptInputType_autofocus: unknown;
    static ngAcceptInputType_standalone: unknown;
    static ngAcceptInputType_autoHeight: unknown;
}
