import { ChangeDetectorRef, EventEmitter, Injector, OnInit } from '@angular/core';
import { UntypedFormBuilder } from '@angular/forms';
import { PopoverController, ToastController } from '@ionic/angular';
import { AppForm } from '../../core/form/form.class';
import { MatAutocompleteField } from '../material/autocomplete/material.autocomplete';
import { MatAutocompleteFieldConfig } from '../material/autocomplete/material.autocomplete.config';
import { INamedFilter, INamedFilterFilter, NamedFilter } from './named-filter.model';
import { INamedFilterService, NamedFilterLoadOptions, NamedFilterWatchOptions } from './named-filter.service';
import { MatFormFieldAppearance, SubscriptSizing } from '@angular/material/form-field';
import * as i0 from "@angular/core";
export type NamedFilterSelectorButtonsPosition = 'matSuffix' | 'after';
export declare class NamedFilterSelector extends AppForm<{
    namedFilter: any;
}> implements OnInit {
    protected injector: Injector;
    protected formBuilder: UntypedFormBuilder;
    protected cd: ChangeDetectorRef;
    protected toastController: ToastController;
    protected popoverController: PopoverController;
    protected dataService: INamedFilterService<INamedFilter<any>, INamedFilterFilter<any, any>, NamedFilterWatchOptions, NamedFilterLoadOptions>;
    protected readonly logPrefix = "[named-filter-selector]";
    private _entityName;
    private _deleteDisabled;
    mobile: boolean;
    set entityName(entityName: string);
    get entityName(): string;
    appearance: MatFormFieldAppearance;
    subscriptSizing: SubscriptSizing;
    filterContentProvider: () => any;
    filterImportCallback: (namedFilter: NamedFilter) => Promise<NamedFilter>;
    filterFormDirty: boolean;
    showButtons: boolean;
    exportFileNamePrefix: string;
    autocompleteConfig: MatAutocompleteFieldConfig;
    dropButtonTitle: string;
    clearButtonTitle: string;
    detectChangeOnSelectFilter: boolean;
    buttonsPosition: NamedFilterSelectorButtonsPosition;
    set disabled(_disabled: boolean);
    get disabled(): boolean;
    get isNew(): boolean;
    get saveDisabled(): boolean;
    get deleteDisabled(): boolean;
    get dirty(): boolean;
    filterSelected: EventEmitter<any>;
    filterDeleted: EventEmitter<NamedFilter<NamedFilter<any>>>;
    filterCleared: EventEmitter<void>;
    autocompleteField: MatAutocompleteField;
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef, toastController: ToastController, popoverController: PopoverController, dataService: INamedFilterService<INamedFilter<any>, INamedFilterFilter<any, any>, NamedFilterWatchOptions, NamedFilterLoadOptions>);
    ngOnInit(): void;
    getFilter(): any;
    markForCheck(): void;
    save(event: UIEvent): Promise<void>;
    delete(event?: UIEvent): Promise<void>;
    onMoreOptionsClick(event: Event): void;
    export(event?: UIEvent): Promise<void>;
    import(event: Event): Promise<void>;
    protected onFilterChanges(value: NamedFilter | string): Promise<void>;
    protected setControlValue(value: NamedFilter): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NamedFilterSelector, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NamedFilterSelector, "app-named-filter-selector", never, { "mobile": { "alias": "mobile"; "required": false; }; "entityName": { "alias": "entityName"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "subscriptSizing": { "alias": "subscriptSizing"; "required": false; }; "filterContentProvider": { "alias": "filterContentProvider"; "required": false; }; "filterImportCallback": { "alias": "filterImportCallback"; "required": false; }; "filterFormDirty": { "alias": "filterFormDirty"; "required": false; }; "showButtons": { "alias": "showButtons"; "required": false; }; "exportFileNamePrefix": { "alias": "exportFileNamePrefix"; "required": false; }; "autocompleteConfig": { "alias": "autocompleteConfig"; "required": false; }; "dropButtonTitle": { "alias": "dropButtonTitle"; "required": false; }; "clearButtonTitle": { "alias": "clearButtonTitle"; "required": false; }; "detectChangeOnSelectFilter": { "alias": "detectChangeOnSelectFilter"; "required": false; }; "buttonsPosition": { "alias": "buttonsPosition"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; }, { "filterSelected": "filterSelected"; "filterDeleted": "filterDeleted"; "filterCleared": "filterCleared"; }, never, never, false, never>;
}
