import { Entity, IEntity } from '../../core/services/model/entity.model';
import { EntityFilter, IEntityFilter } from '../../core/services/model/filter.model';
export interface INamedFilter<T extends INamedFilter<T>> extends IEntity<T> {
    name: string;
    entityName: string;
    content: any;
    recorderPersonId: number;
    recorderDepartmentId: number;
}
export declare class NamedFilter<T extends NamedFilter<any> = NamedFilter<any>> extends Entity<T> implements INamedFilter<T> {
    static fromObject: (source: any, opts?: any) => NamedFilter;
    name: string;
    entityName: string;
    content: any;
    recorderPersonId: number;
    recorderDepartmentId: number;
    fromObject(source: any, opts?: any): void;
}
export interface INamedFilterFilter<F extends INamedFilterFilter<any, T>, T extends INamedFilter<T>> extends IEntityFilter<F, T> {
    searchText: string;
    entityName: string;
    recorderPersonId: number;
    recorderDepartmentId: number;
}
export declare class NamedFilterFilter<F extends NamedFilterFilter<any, T> = NamedFilterFilter<any, any>, T extends NamedFilter<any> = NamedFilter<any>> extends EntityFilter<F, T> implements INamedFilterFilter<F, T> {
    static fromObject: (source: any, opts?: any) => NamedFilterFilter;
    searchText: string;
    entityName: string;
    recorderPersonId: number;
    recorderDepartmentId: number;
    fromObject(source: any, opts?: any): void;
}
