import { InjectionToken } from '@angular/core';
import { EntitiesServiceLoadOptions, EntityServiceWatchOptions, IEntitiesService, IEntityService, LoadResult, SuggestService } from '../services/entity-service.class';
import { GraphqlService } from '../../core/graphql/graphql.service';
import { BaseEntityService, BaseEntityServiceOptions } from '../../core/services/base-entity-service.class';
import { PlatformService } from '../../core/services/platform.service';
import { AccountService } from '../../core/services/account.service';
import { INamedFilter, INamedFilterFilter, NamedFilter, NamedFilterFilter } from './named-filter.model';
import * as i0 from "@angular/core";
export declare const APP_NAMED_FILTER_SERVICE: InjectionToken<INamedFilterService<any, any, any, any>>;
export interface INamedFilterService<T extends INamedFilter<T>, F extends INamedFilterFilter<F, T>, WO extends NamedFilterWatchOptions, LO extends NamedFilterLoadOptions> extends IEntitiesService<T, F, WO>, IEntityService<T, number, LO>, SuggestService<T, F> {
}
export interface NamedFilterWatchOptions extends EntityServiceWatchOptions {
    withContent?: boolean;
}
export interface NamedFilterLoadOptions extends EntitiesServiceLoadOptions {
    withContent?: boolean;
}
export declare abstract class AbstractNamedFilterService<T extends NamedFilter<T>, F extends NamedFilterFilter<F, T>, WO extends NamedFilterWatchOptions = NamedFilterWatchOptions, LO extends NamedFilterLoadOptions = NamedFilterLoadOptions> extends BaseEntityService<T, F, number> implements INamedFilterService<T, F, WO, LO> {
    protected graphql: GraphqlService;
    protected platform: PlatformService;
    protected account: AccountService;
    protected dataType: new () => T;
    protected filterType: new () => F;
    protected options: BaseEntityServiceOptions<T, number>;
    protected constructor(graphql: GraphqlService, platform: PlatformService, account: AccountService, dataType: new () => T, filterType: new () => F, options: BaseEntityServiceOptions<T, number>);
    suggest(value: any, filter: Partial<F>): Promise<LoadResult<T>>;
    asSuggestFilter(searchText: string, filter?: Partial<F>): F;
    asFilter(source: any): F;
    protected fillDefaultProperties(source: T): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractNamedFilterService<any, any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbstractNamedFilterService<any, any, any, any>, never, never, {}, {}, never, never, false, never>;
}
