import { Observable } from 'rxjs';
import { Predicate } from '@angular/core';
export declare interface FirstOptions {
    timeout?: number;
    stop?: Observable<any>;
    stopError?: boolean | string | Error;
}
export declare interface WaitForOptions extends FirstOptions {
    dueTime?: number;
    checkPeriod?: number;
}
export declare function filterNotNil<T = any>(obs: Observable<T>): Observable<T>;
export declare function filterTrue(obs: Observable<boolean>): Observable<boolean>;
export declare function filterFalse(obs: Observable<boolean>, opts?: FirstOptions): Observable<boolean>;
export declare function firstNotNil<T = any>(obs: Observable<T>, opts?: FirstOptions): Observable<T>;
export declare function firstTrue<T = void>(obs: Observable<boolean>, opts?: FirstOptions, result?: T): Observable<T>;
export declare function firstFalse<T = void>(obs: Observable<boolean>, opts?: FirstOptions, result?: T): Observable<T>;
export declare function firstTruePromise(obs: Observable<boolean>, opts?: FirstOptions): Promise<void>;
export declare function firstFalsePromise(obs: Observable<boolean>, opts?: FirstOptions): Promise<void>;
export declare function firstNotNilPromise<T = any>(obs: Observable<T>, opts?: FirstOptions): Promise<T>;
export declare function chainPromises<T = any>(defers: (() => Promise<any>)[]): Promise<T[]>;
/**
 * Wait form a predicate return true. This need to implement AppFormUtils.waitWhilePending(), AppFormUtils.waitIdle()
 *
 * @param predicate
 * @param opts
 */
export declare function waitFor(predicate: Predicate<void>, opts?: WaitForOptions): Promise<void>;
export declare function waitForTrue(observable: Observable<boolean>, opts?: WaitForOptions): Promise<void>;
export declare function waitForFalse(observable: Observable<boolean>, opts?: WaitForOptions): Promise<void>;
