import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
export declare class NotEmptyArrayPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[]): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<NotEmptyArrayPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<NotEmptyArrayPipe, "isNotEmptyArray", false>;
}
export declare class EmptyArrayPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[]): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<EmptyArrayPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<EmptyArrayPipe, "isEmptyArray", false>;
}
export declare class ArrayLengthPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], args?: {
        greaterThan?: number;
        equals?: number;
        lessThan?: number;
    }): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayLengthPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayLengthPipe, "isArrayLength", false>;
}
export declare class ArrayFirstPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[]): T | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayFirstPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayFirstPipe, "arrayFirst", false>;
}
export declare class ArrayLastPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[]): T | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayLastPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayLastPipe, "arrayLast", false>;
}
export declare class ArrayPluckPipe implements PipeTransform {
    /**
     *
     * @param val
     * @param opts property to get, or options
     */
    transform<T = any>(val: unknown | T[], opts: string | string[] | {
        property: string | string[];
        omitNil?: boolean;
    }): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayPluckPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayPluckPipe, "arrayPluck", false>;
}
export declare class ArrayIncludesPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], searchElement: T, fromIndex?: number): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayIncludesPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayIncludesPipe, "arrayIncludes", false>;
}
export declare class ArrayFilterPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], filterFn: (T: any) => boolean): T[] | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayFilterPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayFilterPipe, "arrayFilter", false>;
}
export declare class ArraySortPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], sortFn: (a: T, b: T) => number): T[] | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArraySortPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArraySortPipe, "arraySort", false>;
}
export declare class ArrayFindByPropertyPipe implements PipeTransform {
    transform<T = any>(items: unknown | T[], property: string | Array<string | number>, findValue: any): T | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayFindByPropertyPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayFindByPropertyPipe, "arrayFindByProperty", false>;
}
export declare class ArrayJoinPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], separator: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayJoinPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayJoinPipe, "arrayJoin", false>;
}
export declare class ArrayDistinctPipe implements PipeTransform {
    transform<T = any>(val: unknown | T[], opts?: string | {
        property: string;
        omitNil?: boolean;
    }): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayDistinctPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ArrayDistinctPipe, "arrayDistinct", false>;
}
export declare class SplitArrayInChunksPipe implements PipeTransform {
    transform<T = any>(value: T[], chunkSize: number): T[][];
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitArrayInChunksPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<SplitArrayInChunksPipe, "splitArrayInChunks", false>;
}
