import { OnDestroy, PipeTransform } from '@angular/core';
import { Moment } from 'moment';
import { TranslateService } from '@ngx-translate/core';
import { MomentDateAdapter } from '@angular/material-moment-adapter';
import * as i0 from "@angular/core";
declare abstract class AbstractDateFormat {
    protected dateAdapter: MomentDateAdapter;
    protected translate: TranslateService;
    private datePattern;
    private dateTimePattern;
    private dateTimeSecondsPattern;
    protected constructor(dateAdapter: MomentDateAdapter, translate: TranslateService);
    transform(value: string | Moment | Date, args?: {
        pattern?: string;
        time?: boolean;
        seconds?: boolean;
    }): string;
    protected _updateTranslations(translations: any): void;
    protected _getTranslationValue(translations: any, key: string, defaultValue: string): string;
}
export declare class DateFormatPipe extends AbstractDateFormat implements PipeTransform {
    constructor(dateAdapter: MomentDateAdapter, translate: TranslateService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DateFormatPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<DateFormatPipe, "dateFormat", false>;
}
export declare class DateFormatService extends AbstractDateFormat implements OnDestroy {
    private _subscription;
    constructor(dateAdapter: MomentDateAdapter, translate: TranslateService);
    ngOnDestroy(): void;
    format(date: Moment, pattern: any): string;
    parse(value: string, parseFormat: any): Moment;
    static ɵfac: i0.ɵɵFactoryDeclaration<DateFormatService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DateFormatService>;
}
export {};
