import { ChangeDetectorRef, OnDestroy, PipeTransform } from '@angular/core';
import { AbstractControl, UntypedFormArray, UntypedFormControl, UntypedFormGroup } from '@angular/forms';
import { FormErrorTranslateOptions, FormErrorTranslator } from '../validator/form-error-adapter.class';
import * as i0 from "@angular/core";
export declare class FormErrorPipe implements PipeTransform, OnDestroy {
    private service;
    private _ref;
    private _value;
    private _lastForm;
    private _lastOptions;
    private _onFormStatusChanges;
    constructor(service: FormErrorTranslator, _ref: ChangeDetectorRef);
    transform(form: UntypedFormGroup, opts?: FormErrorTranslateOptions): string;
    ngOnDestroy(): void;
    private _updateValue;
    /**
     * Clean any existing subscription to change events
     */
    private _dispose;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormErrorPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormErrorPipe, "formError", false>;
}
/**
 * Same a FormErrorPipe
 * @deprecated use `formError` instead
 */
export declare class FormErrorTranslatePipe extends FormErrorPipe {
    constructor(service: FormErrorTranslator, _ref: ChangeDetectorRef);
    transform(form: UntypedFormGroup, opts?: FormErrorTranslateOptions): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormErrorTranslatePipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormErrorTranslatePipe, "translateFormError", false>;
}
export declare class FormGetPipe implements PipeTransform {
    transform(form: AbstractControl, path: Array<string | number> | string): AbstractControl;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormGetPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormGetPipe, "formGet", false>;
}
export declare class FormGetControlPipe implements PipeTransform {
    transform(form: AbstractControl, path?: Array<string | number> | string): UntypedFormControl;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormGetControlPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormGetControlPipe, "formGetControl", false>;
}
export declare class FormGetArrayPipe implements PipeTransform {
    transform(form: AbstractControl, path?: Array<string | number> | string): UntypedFormArray;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormGetArrayPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormGetArrayPipe, "formGetArray", false>;
}
export declare class FormGetGroupPipe implements PipeTransform {
    transform(form: AbstractControl, path?: Array<string | number> | string): UntypedFormGroup;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormGetGroupPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormGetGroupPipe, "formGetGroup", false>;
}
export declare class FormGetValuePipe implements PipeTransform, OnDestroy {
    private _ref;
    private _value;
    private _lastControl;
    private _lastPath;
    private _onControlValueChanges;
    private _onControlStatusChanges;
    constructor(_ref: ChangeDetectorRef);
    transform<T = any>(form: AbstractControl, path?: Array<string | number> | string, listenStatusChanges?: boolean): T;
    ngOnDestroy(): void;
    /**
     * Clean any existing subscription to change events
     */
    private _dispose;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormGetValuePipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FormGetValuePipe, "formGetValue", false>;
}
