import { PipeTransform } from '@angular/core';
import { FormFieldDefinition } from '../form/field.model';
import * as i0 from "@angular/core";
export declare class PropertyGetPipe implements PipeTransform {
    transform(obj: any, args: string | Array<string | number> | {
        key: string;
        defaultValue?: any;
    }): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<PropertyGetPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<PropertyGetPipe, "propertyGet", false>;
}
declare abstract class AbstractValueFormatPipe {
    private _i18nYes;
    private _i18nNo;
    private dateFormat;
    private translate;
    get i18nYes(): string;
    get i18nNo(): string;
    protected valueToString(value: any, definition?: Partial<FormFieldDefinition>): string;
}
export declare class PropertyFormatPipe extends AbstractValueFormatPipe implements PipeTransform {
    transform(obj: any, args: string | Array<string | number> | FormFieldDefinition): string | Promise<string>;
    static ɵfac: i0.ɵɵFactoryDeclaration<PropertyFormatPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<PropertyFormatPipe, "propertyFormat", false>;
    static ɵprov: i0.ɵɵInjectableDeclaration<PropertyFormatPipe>;
}
export declare class ValueFormatPipe extends AbstractValueFormatPipe implements PipeTransform {
    transform(value: any, definition: FormFieldDefinition): string | Promise<string>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ValueFormatPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ValueFormatPipe, "valueFormat", false>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ValueFormatPipe>;
}
export declare class BooleanFormatPipe extends AbstractValueFormatPipe implements PipeTransform {
    transform(value: any, opts?: {
        yesLabel: string;
        noLabel: string;
    }): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<BooleanFormatPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<BooleanFormatPipe, "booleanFormat", false>;
}
export {};
