import { BehaviorSubject, Observable } from 'rxjs';
import { LoadResult, LoadResultByPageFn } from './entity-service.class';
export type CallableWithProgressionFn<O extends CallableWithProgressionOptions> = (opts?: O) => Promise<any>;
export interface CallableWithProgressionOptions {
    maxProgression?: number;
    progression?: BehaviorSubject<number>;
    [key: string]: any;
}
export declare class JobUtils {
    static defers<O extends CallableWithProgressionOptions>(runnableList: CallableWithProgressionFn<O>[], opts?: O): Observable<number>[];
    static defer<O extends CallableWithProgressionOptions>(runnable: CallableWithProgressionFn<O>, opts?: O): Observable<number>;
    static run<O extends CallableWithProgressionOptions>(runnable: CallableWithProgressionFn<O>, opts: O): Observable<number>;
    static fetchAllPages<T>(loadPageFn: LoadResultByPageFn<T>, opts?: {
        progression?: BehaviorSubject<number>;
        maxProgression?: number;
        onPageLoaded?: (pageResult: LoadResult<T>) => any;
        logPrefix?: string;
        fetchSize?: number;
    }): Promise<LoadResult<T>>;
}
