import { BehaviorSubject, Subject, Subscription } from 'rxjs';
import { IStartableService } from './startable-service.class';
import * as i0 from "@angular/core";
/**
 * Same as StartableService, but with a dataSubject instead of a simple 'data' property
 */
export declare abstract class StartableObservableService<T = any, O = any> implements IStartableService<T> {
    readonly dataSubject: BehaviorSubject<T>;
    readonly startSubject: Subject<T>;
    readonly stopSubject: Subject<void>;
    protected _debug: boolean;
    protected _startByReadyFunction: boolean;
    private _started;
    private _startPromise;
    private _startPrerequisite;
    private _subscription;
    protected constructor(prerequisiteService?: {
        ready: () => Promise<any>;
    });
    start(opts?: O): Promise<T>;
    ready(): Promise<T>;
    stop(): Promise<void>;
    restart(opts?: O): Promise<T>;
    get started(): boolean;
    get starting(): boolean;
    get stopped(): boolean;
    protected get data(): T;
    protected set data(value: T);
    protected registerSubscription(sub: Subscription): void;
    protected unregisterSubscription(sub: Subscription): void;
    protected unsubscribe(): void;
    protected ngOnStop(): Promise<void> | void;
    protected abstract ngOnStart(opts?: O): Promise<T>;
    static ɵfac: i0.ɵɵFactoryDeclaration<StartableObservableService<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<StartableObservableService<any, any>, never, never, {}, {}, never, never, false, never>;
}
