import { Subject, Subscription } from 'rxjs';
import * as i0 from "@angular/core";
export interface IStartableService<T = any> {
    started: boolean;
    start(): Promise<T>;
    stop(): Promise<void>;
    ready(): Promise<T>;
}
export declare function isStartableService(data: any): data is IStartableService;
export declare abstract class StartableService<T = any, O = any> implements IStartableService<T> {
    readonly startSubject: Subject<T>;
    readonly stopSubject: Subject<void>;
    protected _debug: boolean;
    protected _startByReadyFunction: boolean;
    protected _data: T;
    private _started;
    private _startPromise;
    private _startPrerequisite;
    private _subscription;
    protected constructor(prerequisiteService?: {
        ready: () => Promise<any>;
    });
    start(opts?: O): Promise<T>;
    ready(): Promise<T>;
    stop(): Promise<void>;
    restart(opts?: O): Promise<T>;
    get started(): boolean;
    get starting(): boolean;
    get stopped(): boolean;
    protected registerSubscription(sub: Subscription): void;
    protected unregisterSubscription(sub: Subscription): void;
    protected unsubscribe(): void;
    protected ngOnStop(): Promise<void> | void;
    protected abstract ngOnStart(opts?: O): Promise<T>;
    static ɵfac: i0.ɵɵFactoryDeclaration<StartableService<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<StartableService<any, any>, never, never, {}, {}, never, never, false, never>;
}
