import { TranslateService } from '@ngx-translate/core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class TranslateContextService {
    protected translate: TranslateService;
    constructor(translate: TranslateService);
    get(key: string | string[], context?: string, interpolateParams?: any): Observable<any>;
    instant(key: string | string[], context?: string, interpolateParams?: any): any;
    /**
     * Compute contextual i18n keys, using the context as suffix.<br>
     * Suffix can be simple name (like 'aaa' - will return ['<key>.aaa']) or complexe (like 'aaa.bbb' - will return ['<key>.aaa.bbb', '<key>.aaa']
     *
     * @param key
     * @param context
     * @private
     */
    contextualKeys(key: string, context: string): string[];
    /**
     * Compute a contextual i18n key, using the context as suffix
     *
     * @param key
     * @param context
     * @private
     */
    contextualKey(key: string, context: string): string;
    private findFirstValid;
    static ɵfac: i0.ɵɵFactoryDeclaration<TranslateContextService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TranslateContextService>;
}
