import { ChangeDetectorRef, InjectionToken, OnInit } from '@angular/core';
import { AlertController, IonModal, ToastController } from '@ionic/angular';
import { BehaviorSubject } from 'rxjs';
import { IStorage } from './storage.utils';
import { IDebugDataService } from '../debug/debug-service.class';
import { TranslateService } from '@ngx-translate/core';
import { Environment } from '../../../environments/environment.class';
import { Log, LogUtils } from '../logging/logger.model';
import { MomentDateAdapter } from '@angular/material-moment-adapter';
import { LogLevel } from '../logging/log-level.model';
import { PlatformService } from '../../core/services/platform.service';
import * as i0 from "@angular/core";
interface StorageItemInfo {
    key: string;
    type: 'array' | 'object' | 'string' | 'number';
    total: number;
}
export declare const APP_STORAGE_EXPLORER_PROTECTED_KEYS: InjectionToken<string[]>;
export declare class StorageExplorerComponent implements OnInit {
    protected platform: PlatformService;
    protected toastController: ToastController;
    protected alertCtrl: AlertController;
    protected translate: TranslateService;
    protected dateAdapter: MomentDateAdapter;
    protected cd: ChangeDetectorRef;
    protected readonly storage: IStorage;
    protected readonly environment: Environment;
    protected readonly debugDataService: IDebugDataService;
    private readonly _protectedKeys;
    private _logPrefix;
    protected $loading: BehaviorSubject<boolean>;
    protected $items: BehaviorSubject<StorageItemInfo[]>;
    protected _logKey: string;
    protected data: any;
    protected logs: Log[];
    protected key: string;
    mobile: boolean;
    showSendButton: boolean;
    sendDataModal: IonModal;
    viewDataModal: IonModal;
    constructor(platform: PlatformService, toastController: ToastController, alertCtrl: AlertController, translate: TranslateService, dateAdapter: MomentDateAdapter, cd: ChangeDetectorRef, storage: IStorage, environment: Environment, debugDataService: IDebugDataService, _protectedKeys: string[]);
    ngOnInit(): void;
    sendDataClick(event: Event, key: string): Promise<void>;
    viewDataClick(event: Event, key: string): Promise<void>;
    sendData(key: string): Promise<void>;
    downloadAsJson(key: string): Promise<void>;
    copyToClipboard(key: string): Promise<void>;
    protected start(): Promise<void>;
    protected refresh(): Promise<void>;
    protected toString(key: string, data: any, html?: boolean): string;
    protected toLogs(data: any): Log[];
    protected clear(key: string): Promise<void>;
    protected trackByFn(index: number, item: StorageItemInfo): any;
    protected levelToColor(level: LogLevel): string;
    protected levelToString: typeof LogUtils.levelToString;
    static ɵfac: i0.ɵɵFactoryDeclaration<StorageExplorerComponent, [null, null, null, null, null, null, null, null, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<StorageExplorerComponent, "app-storage-explorer", never, { "mobile": { "alias": "mobile"; "required": false; }; "showSendButton": { "alias": "showSendButton"; "required": false; }; }, {}, never, never, false, never>;
}
export {};
