import { InjectionToken } from '@angular/core';
export interface IStorage<T = any> {
    readonly driver: string;
    ready(): Promise<T>;
    set(key: string, value: any): Promise<void>;
    get(key: string): Promise<any>;
    remove(key: string): Promise<void>;
    keys(): Promise<string[]>;
    clear(): Promise<void>;
    forEach(iteratorCallback: (value: any, key: string, iterationNumber: number) => any): Promise<void>;
}
export declare const StorageDrivers: {
    SQLLite: string;
    SecureStorage: string;
    WebSQL: string;
    IndexedDB: string;
    LocalStorage: string;
};
export declare const APP_STORAGE: InjectionToken<IStorage<any>>;
