import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { IProgressBarService } from '../services/progress-bar.service';
import { ActivatedRoute, Router } from '@angular/router';
import { IonMenuToggle, IonRouterOutlet, IonSearchbar, NavController } from '@ionic/angular';
import { BehaviorSubject, Observable } from 'rxjs';
import { HammerTapEvent } from '../gesture/hammer.utils';
import { AppColors } from '../types';
import { SearchbarChangeEventDetail as ISearchbarSearchbarChangeEventDetail } from '@ionic/core/dist/types/components/searchbar/searchbar-interface';
import { ProgressBarMode } from '@angular/material/progress-bar';
import * as i0 from "@angular/core";
export declare abstract class ToolbarToken {
    abstract onBackClick: Observable<Event>;
    abstract doBackClick(event: Event): any;
    abstract goBack(): Promise<boolean>;
    abstract canGoBack: boolean;
}
export declare const TOOLBAR_HEADER_ID = "app-toolbar-header";
export declare class ToolbarComponent implements ToolbarToken, OnInit, OnDestroy {
    private route;
    private router;
    private navController;
    private routerOutlet;
    private cd;
    protected progressBarService: IProgressBarService;
    private _closeTapCount;
    private _validateTapCount;
    private _defaultBackHref;
    private _backHref;
    protected readonly progressBarMode$: BehaviorSubject<ProgressBarMode>;
    protected showSearchBar: boolean;
    set progressBarMode(value: ProgressBarMode);
    get progressBarMode(): ProgressBarMode;
    title: string;
    color: AppColors;
    class: string;
    id: string;
    set backHref(value: string);
    get backHref(): string;
    set defaultBackHref(value: string);
    get defaultBackHref(): string;
    hasValidate: boolean;
    hasClose: boolean;
    hasSearch: boolean;
    canGoBack: boolean;
    canShowMenu: boolean;
    onValidate: EventEmitter<Event>;
    onClose: EventEmitter<Event>;
    onValidateAndClose: EventEmitter<Event>;
    onBackClick: EventEmitter<Event>;
    onSearch: EventEmitter<CustomEvent<ISearchbarSearchbarChangeEventDetail>>;
    searchbar: IonSearchbar;
    menuToggle: IonMenuToggle;
    constructor(route: ActivatedRoute, router: Router, navController: NavController, routerOutlet: IonRouterOutlet, cd: ChangeDetectorRef, progressBarService: IProgressBarService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    toggleSearchBar(): Promise<void>;
    doBackClick(event: Event): void;
    goBack(): Promise<boolean>;
    tapClose(event: HammerTapEvent): void;
    tapValidate(event: HammerTapEvent): void;
    protected ionSearchBarChanged(event: Event): void;
    protected markForCheck(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ToolbarComponent, [null, null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ToolbarComponent, "app-toolbar", never, { "progressBarMode": { "alias": "progressBarMode"; "required": false; }; "title": { "alias": "title"; "required": false; }; "color": { "alias": "color"; "required": false; }; "class": { "alias": "class"; "required": false; }; "id": { "alias": "id"; "required": false; }; "backHref": { "alias": "backHref"; "required": false; }; "defaultBackHref": { "alias": "defaultBackHref"; "required": false; }; "hasValidate": { "alias": "hasValidate"; "required": false; }; "hasClose": { "alias": "hasClose"; "required": false; }; "hasSearch": { "alias": "hasSearch"; "required": false; }; "canGoBack": { "alias": "canGoBack"; "required": false; }; "canShowMenu": { "alias": "canShowMenu"; "required": false; }; }, { "onValidate": "onValidate"; "onClose": "onClose"; "onValidateAndClose": "onValidateAndClose"; "onBackClick": "onBackClick"; "onSearch": "onSearch"; }, never, ["[slot=start]", "ion-title, ion-segment", "ion-buttons[slot=end]", "[slot=end]"], false, never>;
    static ngAcceptInputType_hasValidate: unknown;
    static ngAcceptInputType_hasClose: unknown;
    static ngAcceptInputType_hasSearch: unknown;
    static ngAcceptInputType_canGoBack: unknown;
    static ngAcceptInputType_canShowMenu: unknown;
}
