import { ChangeDetectorRef } from '@angular/core';
import { PopoverController } from '@ionic/angular';
import { UploadFileComponent } from './upload-file.component';
import { FileDeleteFn, FileUploadFn, UploadFile } from './upload-file.model';
import { TranslateService } from '@ngx-translate/core';
import * as i0 from "@angular/core";
export interface UploadFilePopoverOptions<T> {
    title?: string;
    uploadFn: FileUploadFn<T>;
    deleteFn?: FileDeleteFn<any>;
    instantUpload?: boolean;
    uniqueFile?: boolean;
    fileExtension?: string;
    maxParallelUpload?: number;
    autoHideDropArea?: boolean;
}
export declare class UploadFilePopover implements UploadFilePopoverOptions<any> {
    protected popoverController: PopoverController;
    protected translate: TranslateService;
    protected cd: ChangeDetectorRef;
    uploader: UploadFileComponent;
    fileExtension: string;
    title: string;
    uniqueFile: boolean;
    instantUpload: boolean;
    uploadFn: FileUploadFn<any>;
    deleteFn: FileDeleteFn<any>;
    maxParallelUpload: number;
    autoHideDropArea: boolean;
    importing: boolean;
    error: string;
    get files(): UploadFile<any>[];
    get disabled(): boolean;
    get valid(): boolean;
    constructor(popoverController: PopoverController, translate: TranslateService, cd: ChangeDetectorRef);
    onValidate(event: any): Promise<any>;
    cancel(): Promise<boolean>;
    protected resetError(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UploadFilePopover, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UploadFilePopover, "app-upload-file-popover", never, { "fileExtension": { "alias": "fileExtension"; "required": false; }; "title": { "alias": "title"; "required": false; }; "uniqueFile": { "alias": "uniqueFile"; "required": false; }; "instantUpload": { "alias": "instantUpload"; "required": false; }; "uploadFn": { "alias": "uploadFn"; "required": false; }; "deleteFn": { "alias": "deleteFn"; "required": false; }; "maxParallelUpload": { "alias": "maxParallelUpload"; "required": false; }; "autoHideDropArea": { "alias": "autoHideDropArea"; "required": false; }; }, {}, never, never, false, never>;
}
