import { ChangeDetectorRef, ElementRef } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { FileDeleteFn, FileUploadFn, UploadFile } from './upload-file.model';
import { WaitForOptions } from '../observables';
import * as i0 from "@angular/core";
export declare class UploadFileComponent {
    protected cd: ChangeDetectorRef;
    protected translate: TranslateService;
    fileDropEl: ElementRef;
    fileExtension: string;
    uniqueFile: boolean;
    instantUpload: boolean;
    uploadFn: FileUploadFn<any>;
    deleteFn: FileDeleteFn<any>;
    maxParallelUpload: number;
    autoHideDropArea: boolean;
    files: UploadFile<any>[];
    uploading: boolean;
    get processingFiles(): UploadFile<any>[];
    get processedFiles(): UploadFile<any>[];
    get processingFilesCount(): number;
    constructor(cd: ChangeDetectorRef, translate: TranslateService);
    /**
     * on file drop handler
     */
    onFileDropped(event: any): void;
    /**
     * handle file from browsing
     */
    fileBrowseHandler(files: any): void;
    /**
     * Delete file from files list
     *
     * @param index (File index)
     */
    deleteFile(index: number): Promise<void>;
    /**
     * Convert Files list to normal array list
     *
     * @param files (Files List)
     */
    prepareFilesList(files: FileList | File[]): void;
    /**
     * Execute upload
     */
    uploadFiles(files?: File[]): Promise<UploadFile<any>[]>;
    waitIdle(opts?: WaitForOptions): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<UploadFileComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UploadFileComponent, "app-upload-file", never, { "fileExtension": { "alias": "fileExtension"; "required": false; }; "uniqueFile": { "alias": "uniqueFile"; "required": false; }; "instantUpload": { "alias": "instantUpload"; "required": false; }; "uploadFn": { "alias": "uploadFn"; "required": false; }; "deleteFn": { "alias": "deleteFn"; "required": false; }; "maxParallelUpload": { "alias": "maxParallelUpload"; "required": false; }; "autoHideDropArea": { "alias": "autoHideDropArea"; "required": false; }; }, {}, never, never, false, never>;
}
