import { InjectionToken } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { AbstractControl } from '@angular/forms';
import { ObjectMap } from '../types';
import { FormErrors } from '../forms';
import { TranslateContextService } from '../services/translate-context.service';
import * as i0 from "@angular/core";
export declare const APP_FORM_ERROR_I18N_KEYS: InjectionToken<ObjectMap<string>>;
export interface IFormPathTranslatorOptions {
    i18nPrefix?: string;
    i18nSuffix?: string;
    [key: string]: any;
}
export interface IFormPathTranslator<O extends IFormPathTranslatorOptions = IFormPathTranslatorOptions> {
    translateFormPath: (path: string, opts?: O) => string;
}
export interface FormErrorTranslateOptions extends IFormPathTranslatorOptions {
    pathTranslator?: IFormPathTranslator;
    separator?: string;
    recursive?: boolean;
}
export declare class FormErrorTranslator implements IFormPathTranslator {
    private translate;
    private translateContext;
    private readonly errorI18nKeys;
    constructor(translate: TranslateService, translateContext: TranslateContextService, errorI18nKeys: ObjectMap<string>);
    translateFormErrors(control: AbstractControl, opts?: FormErrorTranslateOptions): string;
    translateErrors(errors: FormErrors, opts?: FormErrorTranslateOptions): string;
    translateFormPath(path: string, opts?: FormErrorTranslateOptions): string;
    translateError(errorKey: string, errorContent?: any): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormErrorTranslator, [null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FormErrorTranslator>;
}
