export declare class VersionUtils {
    static compare: typeof compareVersionNumbers;
    static isCompatible: typeof isVersionCompatible;
    static isSame: typeof isSameVersion;
}
/**
 * Compare two software version numbers (e.g. 1.7.1)
 * Returns:
 *
 *  0 if they're identical
 *  negative if v1 < v2
 *  positive if v1 > v2
 *  Nan if they in the wrong format
 *
 *  E.g.:
 *
 *  assert(version_number_compare("1.7.1", "1.6.10") > 0);
 *  assert(version_number_compare("1.7.1", "1.7.10") < 0);
 *
 *  "Unit tests": http://jsfiddle.net/ripper234/Xv9WL/28/
 *
 *  Taken from http://stackoverflow.com/a/6832721/11236
 */
export declare function compareVersionNumbers(v1: any, v2: any): number;
export declare function isVersionCompatible(minVersion: any, actualVersion: any): boolean;
export declare function isSameVersion(v1: any, v2: any): boolean;
