import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ThemePalette } from '@angular/material/core';
import { IJobProgressionService } from './job-progression.service';
import { JobProgression } from './job-progression.model';
import { BehaviorSubject } from 'rxjs';
import { PopoverController } from '@ionic/angular';
import { IUserEventAction } from '../../user-event/user-event.model';
import { ProgressSpinnerMode } from '@angular/material/progress-spinner';
import { RxState } from '@rx-angular/state';
import * as i0 from "@angular/core";
export interface JobProgressionOptions {
    autoHide: boolean;
    autoHideDelay: number;
    autoRemove: boolean;
    autoRemoveDelay: number;
}
export interface JobProgressionIconState {
    visible: boolean;
    mode: ProgressSpinnerMode;
    value: number;
    jobProgressions: BehaviorSubject<JobProgression>[];
    jobCount: number;
}
export declare class JobProgressionIcon extends RxState<JobProgressionIconState> implements OnInit, OnDestroy {
    protected jobProgressionService: IJobProgressionService;
    protected popoverController: PopoverController;
    protected cd: ChangeDetectorRef;
    debug: boolean;
    titleI18n: string;
    options: JobProgressionOptions;
    autoHide: boolean;
    headerActions: IUserEventAction[];
    jobFinished: EventEmitter<number>;
    disabled: boolean;
    color: ThemePalette;
    jobProgressions$: import("rxjs").Observable<BehaviorSubject<JobProgression>[]>;
    jobCount$: import("rxjs").Observable<number>;
    visible$: import("rxjs").Observable<boolean>;
    mode$: import("rxjs").Observable<ProgressSpinnerMode>;
    value$: import("rxjs").Observable<number>;
    protected autoHideDelay: number;
    protected autoRemove: boolean;
    protected autoRemoveDelay: number;
    private _listPopover;
    private _subscriptions;
    private _subscriptionsById;
    private _logPrefix;
    constructor(jobProgressionService: IJobProgressionService, popoverController: PopoverController, cd: ChangeDetectorRef);
    get jobProgressions(): BehaviorSubject<JobProgression>[];
    ngOnInit(): void;
    protected startListenJob(id: number, job?: JobProgression): BehaviorSubject<JobProgression>;
    protected stopListenJob(id: number, opts?: {
        emitEvent?: boolean;
    }): void;
    protected getProgression(id: number): BehaviorSubject<JobProgression> | undefined;
    protected updateValue(): void;
    showList(event: Event): Promise<void>;
    protected markForCheck(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<JobProgressionIcon, [{ optional: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<JobProgressionIcon, "app-job-progression-icon", never, { "debug": { "alias": "debug"; "required": false; }; "titleI18n": { "alias": "titleI18n"; "required": false; }; "options": { "alias": "options"; "required": false; }; "autoHide": { "alias": "autoHide"; "required": false; }; "headerActions": { "alias": "headerActions"; "required": false; }; }, { "jobFinished": "jobFinished"; }, never, never, false, never>;
}
