import { InjectionToken } from '@angular/core';
import { JobProgression } from './job-progression.model';
import { BaseGraphqlService } from '../../../core/services/base-graphql-service.class';
import { GraphqlService } from '../../../core/graphql/graphql.service';
import { Environment } from '../../../../environments/environment.class';
import { Observable } from 'rxjs';
import { FetchPolicy } from '@apollo/client/core';
import * as i0 from "@angular/core";
export declare const APP_JOB_PROGRESSION_SERVICE: InjectionToken<IJobProgressionService>;
export interface IJobProgressionService {
    watchAll(): Observable<JobProgression[]>;
    addJob(id: number, job?: JobProgression): any;
    removeJob(id: number): any;
    listenChanges(id: number, options?: {
        interval?: number;
        fetchPolicy?: FetchPolicy;
    }): Observable<JobProgression>;
}
export declare class JobProgressionService extends BaseGraphqlService<JobProgression> implements IJobProgressionService {
    protected graphql: GraphqlService;
    protected environment: Environment;
    private jobsSubject;
    constructor(graphql: GraphqlService, environment: Environment);
    watchAll(): Observable<JobProgression[]>;
    addJob(id: number, job?: JobProgression): void;
    removeJob(id: number): void;
    listenChanges(id: number, options?: {
        interval?: number;
        fetchPolicy?: FetchPolicy;
    }): Observable<JobProgression>;
    static ɵfac: i0.ɵɵFactoryDeclaration<JobProgressionService, [null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<JobProgressionService>;
}
