import { ChangeDetectorRef, Injector, OnInit } from '@angular/core';
import { UntypedFormBuilder, UntypedFormGroup } from '@angular/forms';
import { Message } from './message.model';
import { AppForm } from '../../core/form/form.class';
import { Person } from '../../core/services/model/person.model';
import { SuggestFn } from '../../shared/services/entity-service.class';
import { PersonFilter } from '../../admin/services/filter/person.filter';
import * as i0 from "@angular/core";
export declare class MessageForm extends AppForm<Message> implements OnInit {
    private formBuilder;
    private readonly cd;
    readonly mobile: boolean;
    suggestFn: SuggestFn<Person, PersonFilter>;
    subjectMinLength: number;
    subjectMaxLength: number;
    bodyMaxLength: number;
    bodyAutoHeight: boolean;
    canSelectType: boolean;
    canRecipientFilter: boolean;
    recipientFilterCount: number;
    types: readonly {
        id: string;
        icon: string;
        label: string;
    }[];
    constructor(injector: Injector, formBuilder: UntypedFormBuilder, cd: ChangeDetectorRef);
    ngOnInit(): void;
    isSamePerson(o1: Person, o2: Person): boolean;
    protected updateFormGroup(formGroup: UntypedFormGroup, opts?: {
        type?: string;
        recipientRequired?: boolean;
    }): void;
    protected markForCheck(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MessageForm, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MessageForm, "app-message-form", never, { "suggestFn": { "alias": "suggestFn"; "required": false; }; "subjectMinLength": { "alias": "subjectMinLength"; "required": false; }; "subjectMaxLength": { "alias": "subjectMaxLength"; "required": false; }; "bodyMaxLength": { "alias": "bodyMaxLength"; "required": false; }; "bodyAutoHeight": { "alias": "bodyAutoHeight"; "required": false; }; "canSelectType": { "alias": "canSelectType"; "required": false; }; "canRecipientFilter": { "alias": "canRecipientFilter"; "required": false; }; "recipientFilterCount": { "alias": "recipientFilterCount"; "required": false; }; }, {}, never, never, false, never>;
}
