import { AfterViewInit, ChangeDetectorRef, OnInit } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { Message } from './message.model';
import { Person } from '../../core/services/model/person.model';
import { SuggestFn } from '../../shared/services/entity-service.class';
import { PersonFilter } from '../../admin/services/filter/person.filter';
import { LocalSettingsService } from '../../core/services/local-settings.service';
import { AccountService } from '../../core/services/account.service';
import * as i0 from "@angular/core";
export interface MessageModalOptions {
    suggestFn: SuggestFn<Person, PersonFilter>;
    data?: Message;
    canSelectType?: boolean;
    canRecipientFilter?: boolean;
    recipientFilterCount?: number;
}
export declare class MessageModal implements OnInit, AfterViewInit, MessageModalOptions {
    protected settings: LocalSettingsService;
    protected viewCtrl: ModalController;
    protected accountService: AccountService;
    protected cd: ChangeDetectorRef;
    readonly mobile: boolean;
    suggestFn: SuggestFn<Person, PersonFilter>;
    data: Message;
    canSelectType: boolean;
    canRecipientFilter: boolean;
    recipientFilterCount: number;
    private form;
    constructor(settings: LocalSettingsService, viewCtrl: ModalController, accountService: AccountService, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    cancel(): void;
    doSubmit(): Promise<any>;
    protected markForCheck(): void;
    protected markAsLoading(opts?: {
        emitEvent?: boolean;
    }): void;
    protected markAsLoaded(opts?: {
        emitEvent?: boolean;
    }): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MessageModal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MessageModal, "app-message-modal", never, { "suggestFn": { "alias": "suggestFn"; "required": false; }; "data": { "alias": "data"; "required": false; }; "canSelectType": { "alias": "canSelectType"; "required": false; }; "canRecipientFilter": { "alias": "canRecipientFilter"; "required": false; }; "recipientFilterCount": { "alias": "recipientFilterCount"; "required": false; }; }, {}, never, never, false, never>;
}
