import { Entity, EntityAsObjectOptions } from '../../core/services/model/entity.model';
import { StoreObject } from '@apollo/client/core';
import { EntityFilter } from '../../core/services/model/filter.model';
import { Person } from '../../core/services/model/person.model';
import { PersonFilter } from '../../admin/services/filter/person.filter';
import { FilterFn } from '../../shared/types';
export declare const MessageTypes: {
    INBOX_MESSAGE: string;
    EMAIL: string;
    FEED: string;
};
export declare const MessageTypeList: readonly {
    id: string;
    icon: string;
    label: string;
}[];
export declare class Message extends Entity<Message> {
    static fromObject: (source: any, opts?: any) => Message;
    type: string;
    issuer: Person;
    recipients: Person[];
    recipientFilter: PersonFilter;
    subject: string;
    body: string;
    constructor();
    fromObject(source: any, opts?: any): void;
    asObject(opts?: EntityAsObjectOptions): StoreObject;
}
export declare class MessageFilter extends EntityFilter<MessageFilter, Message> {
    static fromObject: (source: any, opts?: any) => MessageFilter;
    fromObject(source: any, opts?: any): void;
    protected buildFilter(): FilterFn<Message>[];
}
