import { GraphqlService } from '../../core/graphql/graphql.service';
import { ModalController, ToastController } from '@ionic/angular';
import { TranslateService } from '@ngx-translate/core';
import { BaseGraphqlService } from '../../core/services/base-graphql-service.class';
import { Environment } from '../../../environments/environment.class';
import { Message, MessageFilter } from './message.model';
import { ShowToastOptions } from '../../shared/toast/toasts';
import { MessageModalOptions } from './message.modal';
import * as i0 from "@angular/core";
export declare class MessageService extends BaseGraphqlService<Message, MessageFilter> {
    protected graphql: GraphqlService;
    protected translate: TranslateService;
    protected modalCtrl: ModalController;
    protected toastController: ToastController;
    protected environment: Environment;
    constructor(graphql: GraphqlService, translate: TranslateService, modalCtrl: ModalController, toastController: ToastController, environment: Environment);
    /**
     * Send a message to recipient(s)
     *
     * @param entity
     * @param opts
     */
    send(entity: Message, opts?: {
        showToast?: boolean;
    }): Promise<boolean>;
    openComposeModal(options: MessageModalOptions & {
        showToast?: boolean;
    }): Promise<any>;
    protected showToast(opts: ShowToastOptions): Promise<import("@ionic/core").OverlayEventDetail<any>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<MessageService, [null, null, null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MessageService>;
}
