import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
import { PopoverController } from '@ionic/angular';
import { IUserEventService } from '../user-event.service';
import { IUserEvent, IUserEventAction, IUserEventFilter } from '../user-event.model';
import { AccountService } from '../../../core/services/account.service';
import * as i0 from "@angular/core";
export declare class UserEventNotificationIcon implements OnInit, OnDestroy {
    userEventService: IUserEventService<IUserEvent<any>, IUserEventFilter<any>>;
    protected accountService: AccountService;
    protected popoverController: PopoverController;
    private cd;
    private _logPrefix;
    private _readEvent;
    private _readEvents;
    debug: boolean;
    titleI18n: string;
    disabled: boolean;
    filter: any;
    autoHide: boolean;
    headerActions: IUserEventAction[];
    footerActions: IUserEventAction[];
    protected visible: boolean;
    protected readonly countChanges$: Observable<number>;
    constructor(userEventService: IUserEventService<IUserEvent<any>, IUserEventFilter<any>>, accountService: AccountService, popoverController: PopoverController, cd: ChangeDetectorRef);
    ngOnInit(): Promise<void>;
    ngOnDestroy(): void;
    showList(event: Event): Promise<void>;
    protected setVisible(value: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserEventNotificationIcon, [{ optional: true; }, null, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UserEventNotificationIcon, "app-user-event-notification-icon", never, { "debug": { "alias": "debug"; "required": false; }; "titleI18n": { "alias": "titleI18n"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "filter": { "alias": "filter"; "required": false; }; "autoHide": { "alias": "autoHide"; "required": false; }; "headerActions": { "alias": "headerActions"; "required": false; }; "footerActions": { "alias": "footerActions"; "required": false; }; }, {}, never, never, false, never>;
}
