import { Entity, EntityAsObjectOptions } from '../../../core/services/model/entity.model';
import { Moment } from 'moment';
import { FilterFn, IconRef } from '../../../shared/types';
import { EventLevel, IUserEvent, IUserEventAction, IUserEventFilter } from '../user-event.model';
import { EntityFilter } from '../../../core/services/model/filter.model';
import { StoreObject } from '@apollo/client/core';
export declare class UserEventTest extends Entity<UserEventTest> implements IUserEvent<UserEventTest> {
    static fromObject: (source: any, opts?: any) => UserEventTest;
    type: string;
    level: EventLevel;
    issuer: string;
    recipient: string;
    creationDate: Moment;
    readDate: Moment;
    message: string | undefined;
    content: string | any;
    hash: string;
    signature: string;
    readSignature: string;
    avatar?: string;
    avatarIcon?: IconRef;
    icon?: IconRef;
    jobId?: number;
    actions?: IUserEventAction[];
    constructor();
    asObject(opts?: EntityAsObjectOptions): any;
    fromObject(source: any): void;
}
export declare class UserEventTestFilter extends EntityFilter<UserEventTestFilter, UserEventTest> implements IUserEventFilter<UserEventTest> {
    static fromObject: (source: any, opts?: any) => UserEventTestFilter;
    types: string[];
    levels: EventLevel[];
    issuers: string[];
    recipients: string[];
    startDate: Moment;
    includedIds: number[];
    excludeRead: boolean;
    jobId: number;
    fromObject(source: any, opts?: any): void;
    protected buildFilter(): FilterFn<UserEventTest>[];
    asObject(opts?: EntityAsObjectOptions): StoreObject;
}
