import { AbstractUserEventService, UserEventLoadOptions, UserEventWatchOptions } from '../user-event.service';
import { Observable } from 'rxjs';
import { GraphqlService } from '../../../core/graphql/graphql.service';
import { AccountService } from '../../../core/services/account.service';
import { NetworkService } from '../../../core/services/network.service';
import { TranslateService } from '@ngx-translate/core';
import { Environment } from '../../../../environments/environment.class';
import { FetchPolicy } from '@apollo/client/core';
import { LoadResult } from '../../../shared/services/entity-service.class';
import { SortDirection } from '@angular/material/sort';
import { UserEventTest, UserEventTestFilter } from './user-event.testing.model';
import { EntitySaveOptions } from '../../../core/services/base-entity-service.class';
import * as i0 from "@angular/core";
export declare class UserEventTestService extends AbstractUserEventService<UserEventTest, UserEventTestFilter> {
    protected graphql: GraphqlService;
    protected accountService: AccountService;
    protected network: NetworkService;
    protected translate: TranslateService;
    protected environment: Environment;
    private $userEvents;
    private $newUserEvents;
    constructor(graphql: GraphqlService, accountService: AccountService, network: NetworkService, translate: TranslateService, environment: Environment);
    fromObject(source: any): UserEventTest;
    add(entity: UserEventTest): Promise<UserEventTest>;
    replaceLast(entity: UserEventTest): Promise<void>;
    asFilter(filter: Partial<any>): any;
    count(filter: any, options?: {
        fetchPolicy?: FetchPolicy;
    }): Promise<number>;
    delete(entity: any): Promise<any>;
    deleteAll(data: any[], opts?: any): Promise<any>;
    listenAllChanges(filter: any, options?: UserEventLoadOptions<UserEventTest> & {
        interval?: number;
    }): Observable<any[]>;
    save(entity: any, options?: EntitySaveOptions<UserEventTest>): Promise<any>;
    saveAll(data: any[], opts?: any): Promise<any[]>;
    protected defaultRecipient(): any;
    watchAll(offset: number, size: number, sortBy?: string, sortDirection?: SortDirection, filter?: Partial<any>, opts?: UserEventWatchOptions<UserEventTest>): Observable<LoadResult<any>>;
    loadAll(offset: number, size: number, sortBy?: string, sortDirection?: SortDirection, filter?: Partial<any>, opts?: UserEventLoadOptions<UserEventTest>): Promise<LoadResult<any>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserEventTestService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<UserEventTestService>;
}
