import { FetchPolicy } from '@apollo/client/core';
import { StorageConfig } from '@ionic/storage';
import { InjectionToken } from '@angular/core';
import { CacheConfig } from 'ionic-cache/lib/interfaces/cache-config.interface';
import { LoggingServiceConfig } from '../app/shared/logging/logging-service.config';
export declare const ENVIRONMENT: InjectionToken<Environment>;
export declare class Environment {
    name: string;
    version: string;
    production: boolean;
    externalEnvironmentUrl?: string;
    baseUrl: string;
    connectionTimeout?: number;
    sameUrlPeer?: boolean;
    peer?: {
        host: string;
        port: number;
        useSsl?: boolean;
        path?: string;
    } | undefined | null;
    defaultPeer?: {
        host: string;
        port: number;
        useSsl?: boolean;
        path?: string;
    } | undefined | null;
    defaultPeers?: {
        host: string;
        port: number;
        useSsl?: boolean;
        path?: string;
    }[];
    peerMinVersion?: string;
    peerDefaultPrefix?: string;
    enableSelectPeerByFeature?: boolean;
    checkAppVersionIntervalInSeconds?: number;
    persistCache?: boolean;
    offline?: boolean;
    apolloFetchPolicy?: FetchPolicy;
    defaultLocale: string;
    defaultLatLongFormat?: 'DD' | 'DDMM' | 'DDMMSS';
    defaultDepartmentId?: number;
    defaultAppName?: string;
    defaultAndroidInstallUrl?: string;
    defaultIOSInstallUrl?: string;
    defaultDesktopInstallUrl?: string;
    useHash?: boolean;
    allowDarkMode?: boolean;
    defaultRoute?: string;
    enableMenu?: boolean;
    logging?: Partial<LoggingServiceConfig>;
    cache?: Partial<CacheConfig>;
    storage?: Partial<StorageConfig>;
    storageSavePeriodMs?: number;
    sourceUrl?: string;
    reportIssueUrl?: string;
    forumUrl?: string;
    helpUrl?: string;
    privacyPolicyUrl?: string;
    termsOfUseUrl?: string;
    defaultAuthValues?: {
        username?: string;
        password?: string;
        token?: string;
    };
    account?: {
        showAccountButton?: boolean;
        enableListenChanges?: boolean;
        listenIntervalInSeconds?: number;
    };
    entityEditor?: {
        enableListenChanges?: boolean;
        listenIntervalInSeconds?: number;
    };
}
