import { HttpClient } from '@angular/common/http';
import { Environment } from './environment.class';
import * as i0 from "@angular/core";
export declare abstract class EnvironmentLoader<T extends Environment = Environment> {
    abstract load(): Promise<T>;
    abstract get(): T;
    static ɵfac: i0.ɵɵFactoryDeclaration<EnvironmentLoader<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EnvironmentLoader<any>, never, never, {}, {}, never, never, false, never>;
}
export declare class EnvironmentHttpLoader<T extends Environment = Environment> extends EnvironmentLoader<T> {
    protected http: HttpClient;
    private readonly _logPrefix;
    protected _debug: boolean;
    protected _environment: T;
    protected _loaded: boolean;
    protected readonly _externalEnvironmentUrl: string;
    constructor(http: HttpClient, defaultEnvironment?: T);
    /**
     * Get the loaded environment. Should be call after loaded
     */
    get(): T;
    load(): Promise<T>;
    protected fetch(url: string): Promise<Partial<T>>;
}
